## program to test two things ###### mb nm suggestion ###
## does an increase in number of constraint variables reduce TAE?
## are the variables not included in spat micr-sim predicted well?
##############
############# replace '/nfs/a237/gyeao' with 's:/gyeao'
#######
getwd() 
setwd("Thesis-software-data/Appendix A/Datasets")  #setwd("s:/gyeao")
rm(list=ls())
####################
install.packages("grid")
install.packages("gridExtra")
install.packages("data.tabl")
install.packages("mipfp")
install.packages("plyr")
install.packages("dplyr")
install.packages("ggplot2")# arrange ggplots in grids 3 by 3 etc # also tried package grid
install.packages("rgdal")#, lib="s:/gyeao/RLibs_4", repos="http://cran.rstudio.com/") # read shapefiles
install.packages("sms")
install.packages("maptools")
install.packages("rgdal")
install.packages("stringr")
install.packages("reshape2")
install.packages("lattice")
install.packages("cowplot")
install.packages("gtable")
install.packages("cumplyr")
install.packages("scales")
install.packages("RColorBrewer")

library(grid)
library(gridExtra)#, lib.loc="s:/gyeao/RLibs_4") 
library("data.table")#, lib.loc="s:/gyeao/RLibs_4")
library(mipfp)
library(plyr)
library(dplyr)
library(ggplot2)
library("rgdal")#, lib.loc="s:/gyeao/RLibs_4") # read shapefiles
library("sms")
library(maptools)
library(rgdal)
library(stringr)
library(reshape2)
library(lattice)
library(cumplyr)
library(scales)
library(RColorBrewer)
library(cowplot) # plot grid
library(gtable)
############################################
getwd()
#setwd("s:/gyeao/analysis_smicrosimulation/nrts_census/project")
#source("mb_nm_tests.R")
###############################################################
convert.magic<-function(obj,types){for(i in 1:length(obj)){FUN<-switch(types[i],c=as.character,n=as.numeric,f=as.factor);obj[,i]<-FUN(obj[,i])};obj}
############## read purpose ##################################################
purpose <- read.csv("individual_NRTS_ID.csv",header=T,stringsAsFactors=FALSE)  
purpose <- purpose[,c("Ind_ID","purpose")]

## s c comments ##
dada5 <- read.csv("individual_NRTS_data.csv",header=T,stringsAsFactors=FALSE,row.names = 2) 
  ind_data_wy_dada<-dada5[,-3]
    ind_data_wy_dada[ind_data_wy_dada=="car_No"]<-"car_0"; ind_data_wy_dada[ind_data_wy_dada=="over_65"]<-"Age65_"
      ind_data_wy_dada <- convert.magic(ind_data_wy_dada,c('n','c','c','c','c','c','c','c','c','c'))
        purpose <- convert.magic(purpose,c('n','c'))
          ind_data_wy_dada <- merge(ind_data_wy_dada,purpose,by.x = "X", by.y = "Ind_ID",all=F)
            ind_data_wy_dada <- ind_data_wy_dada[,-1]; ind_data_wy_dada <- ind_data_wy_dada[,c(1:2,10,3:9)]
colnames(ind_data_wy_dada)[colnames(ind_data_wy_dada)=="purpose"] <- "mode"
## end sc comments ###

#########  routines for stochastic stretegies - sms_sa, sms_hc, ga for variables ranging from 1 to 8 excluding resid, orig, destn ##################################################################################################
ind_data <- ind_data_wy_dada[,-2] ## ind_data <- ind_data_wy_dada[,-c(1:2)]

####### read in data the shapefile from Arcmap #
  shps <- dir(getwd(), "*.shp") # can also use function list.files (with search pattern)
    shps <- gsub("\\.shp$", "", shps) # strip.shp from end of filenames
      temp <- readOGR(dsn=path.expand("Postcode_Areas_WY"), layer="pc_area_wy")
        temp <- as.data.frame(temp); temp <- temp[,c(4,7)]
 
ind_data_area <- merge(ind_data, temp, by.x = "Residence_PC", by.y = "com_sect")     
  ind_data_area$Residence_PC <- ind_data_area$postarea; ind_data_area <- ind_data_area[,-10]      
    ind_data_area <- convert.magic(ind_data_area,c('c','c','c','c','c','c','c','c','c'))
  
census_ref <- data.frame(matrix(ncol = 1, nrow = nrow(ind_data_area))) # create empty dataframe
  for(i in 2:ncol(ind_data_area)){cat <- model.matrix(~ ind_data_area[,i] - 1); census_ref <- cbind(cat,census_ref)} # re-modelling matrices
    census_model_matrix <- census_ref[,-ncol(census_ref)] # remove nuisance row created with empty dataframe
      names(census_model_matrix) <- substring(names(census_model_matrix), 19) # start from 17th character
      
census_model_matrix$Residence_PC <- ind_data_area$Residence_PC; census_model_matrix <- census_model_matrix[,c(28,1:27)]
  census <- aggregate(.~Residence_PC, census_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
    colnames(census)[1] <- "areaid"; census$population <- rowSums(census[,c(2:3)]); census <- census[,c(1,29,2:28)]
  
# sample for survey data in sms-dimitris
  set.seed(1500) # also set near line 96
    survey <- census_model_matrix[sample(nrow(census_model_matrix), round(0.005*nrow(census_model_matrix))), ]
      survey <- survey[,-1]; survey <- setDT(survey, keep.rownames = TRUE)[]
        colnames(survey)[1] <- "pid"
      
in.lexicon <- createLexicon()
  for(i in 2:length(names(survey))){in.lexicon <- addDataAssociation(in.lexicon, c(paste(colnames(survey)[i]), paste(colnames(survey)[i])))}

## monte carlo sampling starting from one to eight variables ##

all.variables <- 8 # values from 1 to 8
  monte.count <- 500 # values from 1 to 5000 if you have 2 days!
    var.list <- c(1,2,3,4,5,6,7,8)
      categs <- vector('numeric', length=0)  ## http://stackoverflow.com/questions/12614953/how-to-create-a-numeric-vector-of-zero-length-in-r
        lexis <- vector('numeric', length=0)
          distrib1 <- data.frame(matrix(NA, nrow = monte.count, ncol = all.variables))
          distrib2 <- data.frame(matrix(NA, nrow = monte.count, ncol = all.variables))
#####
for(n in 1:all.variables){
  for(m in 1:monte.count){vars <- sample(x=var.list, size=n, replace=F)
    categs <- vector('numeric', length=0)
      lexis <- vector('numeric', length=0)
  for(i in 1:n){if(vars[i]==1){temp1<-c(3:4);temp2<-c(1:2);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}else{if(vars[i]==2){temp1<-c(5:6);temp2<-c(3:4);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}
    else{if(vars[i]==3){temp1<-c(7:10);temp2<-c(5:8);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}else{if(vars[i]==4){temp1<-c(11:14);temp2<-c(9:12);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}
      else{if(vars[i]==5){temp1<-c(15:16);temp2<-c(13:14);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}else{if(vars[i]==6){temp1<-c(17:20);temp2<-c(15:18);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}
        else{if(vars[i]==7){temp1<-c(21:27);temp2<-c(19:25);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}else{if(vars[i]==8){temp1<-c(28:29);temp2<-c(26:27);lexis<-append(temp2,lexis);categs<-append(temp1,categs)}else{}}}}}}}}}    
  
mysms <- new("microsimulation", iterations = 90, census = census[,c(1:2,categs)], panel = survey, lexicon = in.lexicon[,lexis])
  myseed <- 1800
## SA
    try02 <- run_parallel_SA(insms = mysms, inseed = myseed) 
      for(i in 1:nrow(census)){empty<-as.data.frame(try02@results[[i]]['selection']); empty$t123456789areaid<-census[i,1]; if(i==1){sim_pop<-empty[0,];sim_pop<-empty}else{ sim_pop<-rbind(sim_pop,empty) } }
        names(sim_pop) <- substring(names(sim_pop), 11)
          sim_pop$population <- 0; sim_pop <- sim_pop[,c(29,30,2:28)]
            sim_pop_v2 <- aggregate(.~areaid, sim_pop, FUN=sum) # creates a structure suitable for comparison with census
              sim_pop_v2$population <- rowSums(sim_pop_v2[,c(3:4)])
                diff <- census; for(i in 1:nrow(census)){for(j in 3:ncol(census)){diff[i,j]<-(abs(sim_pop_v2[i,j]-census[i,j])) }}
                  diff <- diff[,-2]
                    total.diff <- as.numeric(colSums(as.data.frame(colSums(diff[,-1]))))   
                      distrib1[m,n] <- total.diff       
## HC 
    try01 <- run_parallel_HC(insms = mysms, inseed = myseed) 
      for(i in 1:nrow(census)){empty<-as.data.frame(try01@results[[i]]['selection']); empty$t123456789areaid<-census[i,1]; if(i==1){sim_pop<-empty[0,];sim_pop<-empty}else{ sim_pop<-rbind(sim_pop,empty) } }
        names(sim_pop) <- substring(names(sim_pop), 11)
          sim_pop$population <- 0; sim_pop <- sim_pop[,c(29,30,2:28)]
            sim_pop_v2 <- aggregate(.~areaid, sim_pop, FUN=sum) # creates a structure suitable for comparison with census
              sim_pop_v2$population <- rowSums(sim_pop_v2[,c(3:4)])
                diff <- census; for(i in 1:nrow(census)){for(j in 3:ncol(census)){diff[i,j]<-(abs(sim_pop_v2[i,j]-census[i,j])) }}
                  diff <- diff[,-2]
                    total.diff <- as.numeric(colSums(as.data.frame(colSums(diff[,-1]))))   
                      distrib2[m,n] <- total.diff       } ;print(n) } ### end of second loop      

distrib11 <- distrib1; distrib22 <- distrib2          
# write.csv(distrib11,paste("results/spat_micr_sim/distrib11.csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)
# write.csv(distrib22,paste("results/spat_micr_sim/distrib22.csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)

# plotting etc           
    distrib1 <- distrib1[,-c(7:8)]; names(distrib1) <- c('SA-1','SA-2','SA-3','SA-4','SA-5','SA-6')#,'7-Constr','8-Constr') 
      distrib2 <- distrib2[,-c(7:8)]; names(distrib2) <- c('HC-1','HC-2','HC-3','HC-4','HC-5','HC-6')#,'7-Constr','8-Constr') 
        distrib <- cbind(distrib1,distrib2)

        w.plot <- melt(distrib) #
        #cbbPalette <- c("#F0E442","grey","#56B4E9","red","#009E73","#D55E00","#F0E442","grey","#56B4E9","red","#009E73","#D55E00")
        cbbPalette <- c("transparent","grey","transparent","red","transparent","transparent","transparent","grey","transparent","red","transparent","transparent")
        
        lineSizes <- c(2,2,2,2,2,2,4,4,4,4,4,4) #lineSizes <- c(1,1,1,1,1,1,3,3,3,3,3,3) 
        p <- ggplot(w.plot, aes(x=value)) + geom_density(aes(colour=variable,group=variable,size=variable)) + scale_color_manual(values=cbbPalette) + scale_size_manual(values = lineSizes) # gooooood
        grid.newpage();grid.draw(p)
     
#end for now 
##################################################################################################

## end program 

