## program to test the effect of changing the sample ratio on the spatial microsimulation 
## procedure. This script implements the SA and HC spatial microsimulation strategies ###
##############
#######
getwd() 
setwd("Thesis-software-data/Appendix A/Datasets") ##
##setwd("s:/gyeao") ############# replace '/nfs/a237/gyeao' with 's:/gyeao'

rm(list=ls())
####################
install.packages("grid")
install.packages("gridExtra")
install.packages("data.tabl")
install.packages("mipfp")
install.packages("plyr")
install.packages("dplyr")
install.packages("ggplot2")# arrange ggplots in grids 3 by 3 etc # also tried package grid
install.packages("rgdal")#, lib="s:/gyeao/RLibs_4", repos="http://cran.rstudio.com/") # read shapefiles
install.packages("sms")
install.packages("maptools")
install.packages("rgdal")
install.packages("stringr")
install.packages("reshape2")
install.packages("lattice")
install.packages("cowplot")
install.packages("gtable")
install.packages("cumplyr")
install.packages("scales")
install.packages("RColorBrewer")

library(grid)
library(gridExtra)#, lib.loc="s:/gyeao/RLibs_4") 
library("data.table")#, lib.loc="s:/gyeao/RLibs_4")
library(mipfp)
library(plyr)
library(dplyr)
library(ggplot2)
library("rgdal")#, lib.loc="s:/gyeao/RLibs_4") # read shapefiles
library("sms")
library(maptools)
library(rgdal)
library(stringr)
library(reshape2)
library(lattice)
library(cumplyr)
library(scales)
library(RColorBrewer)
library(cowplot) # plot grid
library(gtable)
############################################
getwd()
#setwd("s:/gyeao/analysis_smicrosimulation/nrts_census/project")
#source("mb_nm_tests.R")
###############################################################
convert.magic<-function(obj,types){for(i in 1:length(obj)){FUN<-switch(types[i],c=as.character,n=as.numeric,f=as.factor);obj[,i]<-FUN(obj[,i])};obj}
############## read purpose ##################################################
purpose <- read.csv("individual_NRTS_ID.csv",header=T,stringsAsFactors=FALSE)  
purpose <- purpose[,c("Ind_ID","purpose")]

## s c comments ##
dada5 <- read.csv("individual_NRTS_data.csv",header=T,stringsAsFactors=FALSE,row.names = 2) 
  ind_data_wy_dada<-dada5[,-3]
    ind_data_wy_dada[ind_data_wy_dada=="car_No"]<-"car_0"; ind_data_wy_dada[ind_data_wy_dada=="over_65"]<-"Age65_"
      ind_data_wy_dada <- convert.magic(ind_data_wy_dada,c('n','c','c','c','c','c','c','c','c','c'))
        purpose <- convert.magic(purpose,c('n','c'))
          ind_data_wy_dada <- merge(ind_data_wy_dada,purpose,by.x = "X", by.y = "Ind_ID",all=F)
            ind_data_wy_dada <- ind_data_wy_dada[,-1]; ind_data_wy_dada <- ind_data_wy_dada[,c(1:2,10,3:9)]
colnames(ind_data_wy_dada)[colnames(ind_data_wy_dada)=="purpose"] <- "mode"
## end sc comments ###

#########  routines for stochastic stretegies - sms_sa, sms_hc, ga for variables ranging from 1 to 8 excluding resid, orig, destn ##################################################################################################
ind_data <- ind_data_wy_dada[,-2] ## ind_data <- ind_data_wy_dada[,-c(1:2)]

####### read in data the shapefile from Arcmap #
  shps <- dir(getwd(), "*.shp") # can also use function list.files (with search pattern)
    shps <- gsub("\\.shp$", "", shps) # strip.shp from end of filenames
      temp <- readOGR(dsn=path.expand("Postcode_Areas_WY"), layer="pc_area_wy")
        temp <- as.data.frame(temp); temp <- temp[,c(4,7)]
 
ind_data_area <- merge(ind_data, temp, by.x = "Residence_PC", by.y = "com_sect")     
  ind_data_area$Residence_PC <- ind_data_area$postarea; ind_data_area <- ind_data_area[,-10]      
    ind_data_area <- convert.magic(ind_data_area,c('c','c','c','c','c','c','c','c','c'))
  
census_ref <- data.frame(matrix(ncol = 1, nrow = nrow(ind_data_area))) # create empty dataframe
  for(i in 2:ncol(ind_data_area)){cat <- model.matrix(~ ind_data_area[,i] - 1); census_ref <- cbind(cat,census_ref)} # re-modelling matrices
    census_model_matrix <- census_ref[,-ncol(census_ref)] # remove nuisance row created with empty dataframe
      names(census_model_matrix) <- substring(names(census_model_matrix), 19) # start from 17th character
      
census_model_matrix$Residence_PC <- ind_data_area$Residence_PC; census_model_matrix <- census_model_matrix[,c(28,1:27)]
  census <- aggregate(.~Residence_PC, census_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
    colnames(census)[1] <- "areaid"; census$population <- rowSums(census[,c(2:3)]); census <- census[,c(1,29,2:28)]
  
# sample for survey data in sms-dimitris
  set.seed(1500) # also set near line 96

empty.df <- data.frame(matrix(NA, nrow = 0, ncol = 2)); names(empty.df) <- c('sample.ratio','logTAE')
#nodata <- data.frame(x= numeric(0), y= integer(0), z = character(0))

for(k in 1:4){if(k==1){m<-0.0005}else{if(k==2){m<-0.005}else{if(k==3){m<-0.05}else{if(k==4){m<-0.75}else{}}}}    
  for(q in 1:30){  
      survey <- census_model_matrix[sample(nrow(census_model_matrix), round(m*nrow(census_model_matrix))), ]
      survey <- survey[,-1]; survey <- setDT(survey, keep.rownames = TRUE)[]
        colnames(survey)[1] <- "pid"
      
in.lexicon <- createLexicon()
  for(i in 2:length(names(survey))){in.lexicon <- addDataAssociation(in.lexicon, c(paste(colnames(survey)[i]), paste(colnames(survey)[i])))}
    
mysms <- new("microsimulation", iterations = 90, census = census, panel = survey, lexicon = in.lexicon)
myseed <- 1800

try02 <- run_parallel_SA(insms = mysms, inseed = myseed) # when run parallel is in series use try02[[i]]['selection'] instead of with try02@results[[i]]['selection']
#for(i in 1:nrow(census)){as.data.frame(assign(paste("z",census[i,1],sep=""), try02@results[[i]])['selection']) %>% write.csv(paste("s:/gyeao/results/comb-optim/no_adjustments/","z_",census[i,1],".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)}
  for(i in 1:nrow(census)){empty<-as.data.frame(try02@results[[i]]['selection']); empty$t123456789areaid<-census[i,1]; if(i==1){sim_pop<-empty[0,];sim_pop<-empty}else{ sim_pop<-rbind(sim_pop,empty) } }
    names(sim_pop) <- substring(names(sim_pop), 11)
      sim_pop$population <- 0; sim_pop <- sim_pop[,c(29,30,2:28)]

sim_pop_v2 <- aggregate(.~areaid, sim_pop, FUN=sum) # creates a structure suitable for comparison with census
sim_pop_v2$population <- rowSums(sim_pop_v2[,c(3:4)])

### difference in dataframes ##
diff <- census; for(i in 1:nrow(census)){for(j in 3:ncol(census)){diff[i,j]<-(abs(sim_pop_v2[i,j]-census[i,j])) }}
diff <- diff[order(-diff$population),]; jagdesh <- as.data.frame(diff[,c(1:2)])

for(i in 1:nrow(diff)){for(j in 3:ncol(diff)){diff[i,j]<- diff[i,j]/diff[i,2]  }} # divide by population of zone

#diff$areaid <- as.character(diff$areaid); diff$areaid <- factor(diff$areaid, levels=unique(diff$areaid))

diff <- diff[,-2]
df <- melt(diff ,  id.vars = 'areaid', variable.name = 'series') ; df$value <- log(df$value+0.0) # df$value <- df$value  #

df$logTAE <- paste('100x',m,'%',sep=''); df <- df[,c(4,3,1,2)]; df <- df[,-c(3,4)]; names(df) <- c('Sample.Ratio','logTAE')
empty.df <- rbind(empty.df,df)}} # end of for loop 


df <- empty.df
df$Sample.Ratio <- as.character(df$Sample.Ratio); df$Sample.Ratio <- factor(df$Sample.Ratio, levels=unique(df$Sample.Ratio))

cbbPalette <- c("#F0E442","darkgrey","#56B4E9","red","#009E73")#,"#D55E00")#,"#0072B2")#,"#000000","#999999")
lineSizes <- c(2.5,2.5,2.5,2.5,2.5)# ,2.5)  #c(3.5,3,2.5,2,1.5,1)#,1,0) # c(8,7,6,5,4,3,2,1)
p <- ggplot(df, aes(x=logTAE)) + geom_density(aes(colour = Sample.Ratio, group = Sample.Ratio, size = Sample.Ratio)) + scale_color_manual(values=cbbPalette) + scale_size_manual(values = lineSizes) # + coord_trans(y = "log10")# gooooood
#p <- ggplot(aes(x=value, colour=variable), data=w.plot) + geom_density() ## also look at density(distrib$X3) # kernel density plots http://www.statmethods.net/graphs/density.html  ## plot(d) # plots the results
grid.newpage();grid.draw(p)

