##  ############################
## this program computes the difference between two data tables. 
## One table is generated from a simulated population from microsimulation
## the other table is the reference table created from the NRTs data.
## the program is used to estimate the ability of different spatial microsimulation 
## methods to predict values for those variables that were not included as constraints
## in a deterministic spatial microsimulation
##############
############# replace '/nfs/a237/gyeao' with 's:/gyeao'
#######
getwd() 
setwd("Thesis-software-data/Appendix A/Datasets")  
#setwd("s:/gyeao") ## setwd("/nfs/a237/gyeao")
rm(list=ls())
####################
#install.packages("grid", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("gridExtra", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("data.table", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("mipfp", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("plyr", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("dplyr", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("ggplot2", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")# arrange ggplots in grids 3 by 3 etc # also tried package grid
#install.packages("rgdal", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/") # read shapefiles
#install.packages("sms", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("maptools", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("rgdal", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("stringr", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("reshape2", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("lattice", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("cowplot", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("gtable", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("cumplyr", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("scales", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")
#install.packages("RColorBrewer", lib="/nfs/a237/gyeao/RLibs_4", repos="http://cran.rstudio.com/")

library(grid, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(gridExtra, lib.loc="/nfs/a237/gyeao/RLibs_4") 
library("data.table", lib.loc="/nfs/a237/gyeao/RLibs_4")
library(mipfp, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(plyr, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(dplyr, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(ggplot2, lib.loc="/nfs/a237/gyeao/RLibs_4")
library("rgdal", lib.loc="/nfs/a237/gyeao/RLibs_4") # read shapefiles
library("sms", lib.loc="/nfs/a237/gyeao/RLibs_4")
library(maptools, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(rgdal, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(stringr, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(reshape2, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(lattice, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(cumplyr, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(scales, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(RColorBrewer, lib.loc="/nfs/a237/gyeao/RLibs_4")
library(cowplot, lib.loc="/nfs/a237/gyeao/RLibs_4") # plot grid
library(gtable, lib.loc="/nfs/a237/gyeao/RLibs_4")
############################################
seed = 1750
getwd()
#setwd("/gyeao/project")
#source("mb_nm_tests.R")
###############################################################
convert.magic<-function(obj,types){for(i in 1:length(obj)){FUN<-switch(types[i],c=as.character,n=as.numeric,f=as.factor);obj[,i]<-FUN(obj[,i])};obj}
############## read purpose ##################################################
purpose <- read.csv("individual_NRTS_ID.csv",header=T,stringsAsFactors=FALSE)  
purpose <- purpose[,c("Ind_ID","purpose")]

## s c comments ##
dada5 <- read.csv("individual_NRTS_data.csv",header=T,stringsAsFactors=FALSE,row.names = 2) 
  ind_data_wy_dada<-dada5[,-3]
    ind_data_wy_dada[ind_data_wy_dada=="car_No"]<-"car_0"; ind_data_wy_dada[ind_data_wy_dada=="over_65"]<-"Age65_"
      ind_data_wy_dada <- convert.magic(ind_data_wy_dada,c('n','c','c','c','c','c','c','c','c','c'))
        purpose <- convert.magic(purpose,c('n','c'))
          ind_data_wy_dada <- merge(ind_data_wy_dada,purpose,by.x = "X", by.y = "Ind_ID",all=F)
            ind_data_wy_dada <- ind_data_wy_dada[,-1]; ind_data_wy_dada <- ind_data_wy_dada[,c(1:2,10,3:9)]
colnames(ind_data_wy_dada)[colnames(ind_data_wy_dada)=="purpose"] <- "mode"
## end sc comments ###

#########  routines for stochastic stretegies - sms_sa, sms_hc, ga for variables ranging from 1 to 8 excluding resid, orig, destn ##################################################################################################
ind_data <- ind_data_wy_dada[,-2] ## ind_data <- ind_data_wy_dada[,-c(1:2)]

####### read in data the shapefile from Arcmap #
  shps <- dir(getwd(), "*.shp") # can also use function list.files (with search pattern)
    shps <- gsub("\\.shp$", "", shps) # strip.shp from end of filenames
      temp <- readOGR(dsn=path.expand("/nfs/a237/gyeao/results/dump/ground"), layer="pc_area_wy")
        temp <- as.data.frame(temp); temp <- temp[,c(4,7)]
 
ind_data_area <- merge(ind_data, temp, by.x = "Residence_PC", by.y = "com_sect")     
  ind_data_area$Residence_PC <- ind_data_area$postarea; ind_data_area <- ind_data_area[,-10]      
    ind_data_area <- convert.magic(ind_data_area,c('f','c','c','c','c','c','c','c','c'))  ## was c instead of f
      ind_data_area$Residence_PC <- factor(ind_data_area$Residence_PC, levels=c('LS','BD','WF','HX','HD','OL','S','DN','BB','YO'), ordered=T)

    ind_data_area <- setDT(ind_data_area, keep.rownames = TRUE)[];  
    ind_data_area <- ind_data_area[,c(2:10,1)]; 
#    original <- ind_data_area[1:33200,]; ind_data_area <- ind_data_area[1:33200,] # vector limit 2 ^31 exceeded for >33200 since 9 variables instead of 10
    original <- ind_data_area; ind_data_area <- ind_data_area #
    
#create a census population structure for comparison 
  indi_data <- as.data.frame(original[,-10]); row.names(indi_data) <- 1:nrow(indi_data)
    census_ref <- data.frame(matrix(ncol = 1, nrow = nrow(indi_data))) # create empty dataframe
      for(i in 2:ncol(indi_data)){cat <- model.matrix(~ indi_data[,i] - 1); census_ref <- cbind(cat,census_ref,row.names = NULL)} # re-modelling matrices
        census_model_matrix <- census_ref[,-ncol(census_ref)] # remove nuisance row created with empty dataframe
          names(census_model_matrix) <- substring(names(census_model_matrix), 15) # start from 17th character
            census_model_matrix$Residence_PC <- indi_data$Residence_PC; census_model_matrix <- census_model_matrix[,c(28,1:27)]
              census <- aggregate(.~Residence_PC, census_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
                colnames(census)[1] <- "areaid"; census$population <- rowSums(census[,c(2:3)]); census <- census[,c(1,29,2:28)]
                  census <- census[order(-census$population),]
                    census$areaid <- as.character(census$areaid); census$areaid <- factor(census$areaid, levels=unique(census$areaid))    
##########
# test for constraint varaibles 1,3,5 and 7
for(k in seq(1, 7, by=2)){ #k <- 3 #; k <- 1; k <- 7; k <- 8
    
empty.df <- data.frame(matrix(NA, nrow = 0, ncol = (k+2))); names(empty.df) <- names(ind_data_area)[c(1:(k+1),10)]     

seed.data <- ind_data_area[,-1]; s.ratio <- 0.5 
  seed.df <- seed.data[sample(nrow(seed.data), round(s.ratio*nrow(seed.data))), ]
    seed.df <- as.data.frame(seed.df)
     seed.df <- seed.df[,-seq(k+1, to=ncol(seed.data)-1, by=1)]
      seed.df <- as.data.table(seed.df)    
        seed.table <- table(seed.df)
  
ind_data_df <-  as.data.frame(ind_data_area)        
  ind_data_sub <- as.data.table(ind_data_df[,c(1:(k+1),10)])  
    true.table <- table(ind_data_sub) 
      tgt.data <- list()
        for(i in 1:10){if(k==1){tgt<- true.table[i,,]}else{if(k==3){tgt<-true.table[i,,,,]}else{if(k==5){tgt<-true.table[i,,,,,,]}else{if(k==7){tgt<-true.table[i,,,,,,,,]}else{}}}} ### nrow(true.table)
          tgt.v <- apply(tgt, c(1:k), sum)
            tgt.l.dims <- list(c(1:k))
              tgt.data[i]  <- list(tgt.v)

mipf <- Estimate(seed=seed.table, target.list=tgt.l.dims, target.data=tgt.data[i])# ; print(k)  }}} #http://stackoverflow.com/questions/9931241/r-how-do-i-retrieve-a-matrix-column-and-row-name-by-a-matrix-index-value    

# this snippet replaces "sim.pop <- expand(mipf$x.hat)" ## johans barthelemy ace suggestion in e-mail of 16.02.2017
x <- mipf$x.hat; x.df <- as.data.frame(round(x)); idx <- rep.int(seq_len(nrow(x.df)), x.df$Freq); x.df$Freq <- NULL; result <- x.df[idx, ]; sim.pop <- result
  nam <- arrayInd(i, dim(true.table)); name <- rownames(true.table)[nam[,1]]; 
    if(nrow(sim.pop)==0){}else{sim.pop$Residence_PC <- paste(name,sep="");sim.pop <- sim.pop[,c(ncol(sim.pop),1:(k+1))];empty.df <- rbind(empty.df,sim.pop)} ## at this stage couple other attributes and discard the ID's 'rn'
        }   # end of i loop 

## end of suggestion       
ddd <- merge(empty.df,as.data.frame(ind_data_area)[,c((k+2):ncol(ind_data_area))], by.x='rn',by.y='rn', all=F)
sim.pop  <- ddd[,-1] ## removes ID column
sim.popln <- sim.pop

#create a simulated population structure for comparison 
                sim_ref <- data.frame(matrix(ncol = 1, nrow = nrow(sim.popln))) # create empty dataframe
              for(i in 2:ncol(sim.popln)){cat <- model.matrix(~ sim.popln[,i] - 1); sim_ref <- cbind(cat,sim_ref,row.names = NULL)} # re-modelling matrices
            sim_model_matrix <- sim_ref[,-ncol(sim_ref)] # remove nuisance row created with empty dataframe
          names(sim_model_matrix) <- substring(names(sim_model_matrix), 15) # start from 17th character
        sim_model_matrix$Residence_PC <- sim.popln$Residence_PC; sim_model_matrix <- sim_model_matrix[,c(28,1:27)]
      sim <- aggregate(.~Residence_PC, sim_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
    colnames(sim)[1] <- "areaid"; sim$population <- rowSums(sim[,c(2:3)]); sim <- sim[,c(1,29,2:28)]
  sim <- sim[order(-sim$population),]
sim$areaid <- as.character(sim$areaid); sim$areaid <- factor(sim$areaid, levels=unique(sim$areaid))    
                
### difference in dataframes ##
diff <- census; for(i in 1:nrow(sim)){for(j in 3:ncol(sim)){diff[i,j]<-(abs(sim[i,j]-census[i,j])) }}
# for(i in 1:nrow(diff)){for(j in 3:ncol(diff)){diff[i,j]<- diff[i,j]/diff[i,2]  }} # divide by population of zone

diff <- diff[,-2]; rownames(diff) <- diff[,1]; diff <- diff[,-1]; diff <- t(diff); diff <- as.data.frame(diff)
  diff <- setDT(diff, keep.rownames = TRUE)[] # rownames to first column 
    diff$rn <- as.character(diff$rn); diff$rn <- factor(diff$rn, levels=unique(diff$rn))
assign(paste("diff1",k,sep = ""),diff); print(k)  
} # end of k loop

diff11 <- as.data.frame(diff11); rownames(diff11) <- diff11[,1];diff11 <- diff11[,-1]; diff11 <- as.data.frame(rowSums(diff11)); diff11 <- setDT(diff11, keep.rownames = TRUE)[]
diff13 <- as.data.frame(diff13); rownames(diff13) <- diff13[,1];diff13 <- diff13[,-1]; diff13 <- as.data.frame(rowSums(diff13)); diff13 <- setDT(diff13, keep.rownames = TRUE)[]
diff15 <- as.data.frame(diff15); rownames(diff15) <- diff15[,1];diff15 <- diff15[,-1]; diff15 <- as.data.frame(rowSums(diff15)); diff15 <- setDT(diff15, keep.rownames = TRUE)[]
diff17 <- as.data.frame(diff17); rownames(diff17) <- diff17[,1];diff17 <- diff17[,-1]; diff17 <- as.data.frame(rowSums(diff17)); diff17 <- setDT(diff17, keep.rownames = TRUE)[]

list(diff11,diff13,diff15,diff17) %>%  Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="rn"), .) -> diff.all

diff <- diff.all
diff$rn <- as.character(diff$rn); diff$rn <- factor(diff$rn, levels=unique(diff$rn))
df <- melt(diff ,  id.vars = 'rn', variable.name = 'series') ; df$value <- (df$value) # df$value <- df$value  #

write.csv(df,paste("/gyeao/","sim_pop",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)

# plot routine
setwd("s:/gyeao")
df2 <- read.csv("sim_pop.csv",header=T,stringsAsFactors=FALSE)  
df2 <- df2[,-1]
df2$rn <- as.character(df2$rn); df2$rn <- factor(df2$rn, levels=unique(df2$rn)) 
cbbPalette <- c("#D55E00","red","#56B4E9","#009E73")
lineSizes <- c(3,3,3,3)# ,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2) #c(1,1,1,1,1,1,1,1,1,1)
h <- ggplot(df2, aes(rn,value)) + geom_line(aes(colour = series, group = series, size = series)) + scale_color_manual(values=cbbPalette) + scale_size_manual(values = lineSizes) + theme(axis.text.x = element_text(angle = 90, hjust = 1, vjust = 0.5)) + theme(panel.grid.minor = element_line(colour="grey", size=0.2), panel.grid.major = element_line(colour="grey", size=0.2))  # gooooood
grid.newpage() # http://stackoverflow.com/questions/27929452/r-return-corrplot-as-object/27948707#27948707
g2 <- ggplotGrob(h)
grid.newpage();grid.draw(g2)
##
# addition of histogram
#df22 <- convert.magic(df2,c('c','c','n'))  ## was c instead of f
#ggplot(data = df2, aes(x = rn, y = value, fill = series)) + geom_bar()
ggplot(data = df2, aes(x = rn, y = value, fill = series)) + geom_bar(stat = "identity") + theme(axis.text.x = element_text(angle = 60, hjust = 1))
## end program 

