#####################################################################################
### Program to perform spatial microsimulation to create a ##########################
### simulated representative population of railway passenegers in the UK ############
### this stage of the process prepares the individual level data. ###################
#####################################################################################
############# replace '/nfs/a237/gyeao' with 's:/gyeao'
getwd() #confirm working directory
setwd("/nfs/a237/gyeao")
rm(list=ls()) #removes all objects to start with clean sheet
## memory management in R ####http://adv-r.had.co.nz/memory.html ################################################
################################################################################
#install.packages("")
#library()
install.packages("data.table", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("sms", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("maptools", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("rgdal", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("dplyr", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("stringr", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("ggplot2", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("reshape2", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("mipfp", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
install.packages("magrittr", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")

library(sms, lib.loc="/nfs/a237/gyeao/RLibs")
library(maptools, lib.loc="/nfs/a237/gyeao/RLibs")
library(rgdal, lib.loc="/nfs/a237/gyeao/RLibs")
library(dplyr, lib.loc="/nfs/a237/gyeao/RLibs")
library(stringr, lib.loc="/nfs/a237/gyeao/RLibs")
library(ggplot2, lib.loc="/nfs/a237/gyeao/RLibs")
library(reshape2, lib.loc="/nfs/a237/gyeao/RLibs")
library(data.table, lib.loc="/nfs/a237/gyeao/RLibs") #set names
library(mipfp, lib.loc="/nfs/a237/gyeao/RLibs")
library(magrittr, lib.loc="/nfs/a237/gyeao/RLibs")

#install.packages("data.table")
#install.packages("sms")
#install.packages("maptools")
#install.packages("rgdal")
#install.packages("dplyr")
#install.packages("stringr")
#install.packages("ggplot2")
#install.packages("reshape2")
#install.packages("mipfp")
#install.packages("magrittr")

#library(sms)
#library(maptools)
#library(rgdal)
#library(dplyr)
#library(stringr)
#library(ggplot2)
#library(reshape2)
#library(data.table)
#library(mipfp)
#library(magrittr)
#library(tidyr)
#######################################
convert.magic<-function(obj,types){for(i in 1:length(obj)){FUN<-switch(types[i],c=as.character,n=as.numeric,f=as.factor);obj[,i]<-FUN(obj[,i])};obj}
df.integer <- function(df){is.num <- sapply(df, is.numeric); df[is.num] <- lapply(df[is.num], round, 0); return(df)} # convert real numbers of dataframe (df) to integer
census.format<-function(data){census_ref <- data.frame(matrix(ncol = 1, nrow = nrow(data))) # create empty data.frame
    for(i in 2:ncol(data)){cat <- model.matrix(~ data[,i] - 1); census_ref <- cbind(cat,census_ref)} # re-modelling matrices
      census_model_matrix <- census_ref[,-ncol(census_ref)] # remove nuisance row created with empty dataframe
        names(census_model_matrix) <- substring(names(census_model_matrix), 10 ) # start from 17th character
          census_model_matrix$Residence_PC <- data$Residence_PC; census_model_matrix <- census_model_matrix[,c(ncol(census_model_matrix),1:(ncol(census_model_matrix)-1))]
            census <- aggregate(.~Residence_PC, census_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
              colnames(census)[1] <- "areaid"; 
                census$population <- rowSums(census[,c(2:ncol(census))]); 
                  census <- census[,c(1,ncol(census),2:(ncol(census)-1))]
                    return(census)    } 
census.form<-function(data, df.integer, aa){nam<-names(data); colnames(data)[1] <- "com_sect"; data <- df.integer(df.integer); 
  dd1 <- melt(data); dd1$purpose <- paste(aa, sep=''); dd1 <- dd1[,c(1,2,4,3)]
    dd1 <- merge(dd1, area.sect, by.x='com_sect', by.y='com_sect', all=F); dd1$com_sect <- dd1$postarea; dd1 <- dd1[,-5] # origin
      dd1 <- merge(dd1, area.sect, by.x='variable', by.y='com_sect', all=F); dd1$variable <- dd1$postarea ; dd1 <- dd1[,-5] # destination
        dd1$Residence_PC <- dd1$com_sect; setnames(dd1, old = c('com_sect','variable'), new = c('Orig_PC','Dest_PC')); dd1 <- dd1[,c(5,2,1,3,4)]
          for(qq in 1:nrow(dd1)){dd1[qq,4] <- str_c(paste(dd1[qq,2],'-',sep=''), dd1[qq,4],paste('-', dd1[qq,3],sep=''))}; dd1 <- dd1[,-c(2:3)]
            mode.exp_NTC <- dd1[rep(seq.int(1,nrow(dd1)), dd1$value), 1:2];
                return(mode.exp_NTC)   }

####### read commuters and non-commuters by passenger purpose and ID from script 27.R ###################
purpose <- read.csv("analysis_smicrosimulation/nrts_census/results/Ind_level_nrts/nrts_data.csv",header=T,stringsAsFactors=FALSE)  
purpose <- purpose[,c("Ind_ID","purpose")]

####### read in shapefile relating Sectors to Areas in West Yorkshire #############################################################
area_sect <- readOGR("/nfs/a237/gyeao/results/dump/sector_area", "area_sector"); area_sect <- area_sect@data
area.sect <- area_sect[,c(4,7)]
####### read in aggregate data the 30 shapefiles from Arcmap #############################################################
setwd("/nfs/a237/gyeao/analysis_smicrosimulation/nrts_census/results/9/shapefiles")
shps <- dir(getwd(), "*.shp") # can also use function list.files (with search pattern)
shps <- gsub("\\.shp$", "", shps) # strip.shp from end of filenames
for (shpoo in shps){temp<-readOGR('.',layer=shpoo); assign(shpoo, temp@data)} #for (shp in shps) assign(shp, readOGR('.',layer=shp)) ## shp1 = raster::shapefile(shps[1]) in a loop RLovelace #plot(get(shps[11])) # plot shapefile
setwd("/nfs/a237/gyeao") # return wkdir to first form 

##### creation of the origin  and residence matices #######################################################################
residence <- od_tram
avector <- as.character(residence[['com_sect']]) ; b <- "com_sect"; avector <- c(b,avector)
residence <- residence[avector] # http://stackoverflow.com/questions/7070173/r-friendly-way-to-convert-r-data-frame-column-to-a-vector
origin <- residence

for(i in 1:nrow(od_tram)){for(j in 2:ncol(od_tram)){origin[i,j]<-0.0}} # max(tester)
for(i in 1:nrow(od_tram)){for(j in 2:ncol(od_tram)){residence[i,j]<-od_tram[i,j]+od_notram[i,j]}}
for(i in 1:nrow(od_tram)){origin[i,i+1]<-rowSums(residence[i,-1])}; residence <- origin
nam<-names(origin); names(origin)<-str_c('o-',nam); colnames(origin)[1] <- "com_sect" # stringr package
nam<-names(residence); names(residence)<-str_c('r-',nam); colnames(residence)[1] <- "com_sect" # stringr package

##### edit column names of aggregate data ############################################# this section uses # stringr package
aa<-"NTC"; census.form(od_notram,df.integer=od_notram, aa) %>% census.format() -> mode_NTC  
aa<-"TC"; census.form(od_tram,df.integer=od_tram, aa) %>% census.format() -> mode_TC  
list(mode_NTC[,-2],mode_TC[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> mode

aa<-"step_10"; census.form(step_10,df.integer=step_10, aa) %>% census.format() -> income_10  
aa<-"step_20"; census.form(step_20,df.integer=step_20, aa) %>% census.format() -> income_20  
aa<-"step_30"; census.form(step_30,df.integer=step_30, aa) %>% census.format() -> income_30  
aa<-"step_40"; census.form(step_40,df.integer=step_40, aa) %>% census.format() -> income_40  
aa<-"step_50"; census.form(step_50,df.integer=step_50, aa) %>% census.format() -> income_50  
aa<-"step_60"; census.form(step_60,df.integer=step_60, aa) %>% census.format() -> income_60  
aa<-"step_70"; census.form(step_70,df.integer=step_70, aa) %>% census.format() -> income_70  
list(income_10[,-2],income_20[,-2],income_30[,-2],income_40[,-2],income_50[,-2],income_60[,-2],income_70[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> income

aa<-"ag16_24"; census.form(ag16_24,df.integer=ag16_24, aa) %>% census.format() -> ag16_24  
aa<-"ag25_34"; census.form(ag25_34,df.integer=ag25_34, aa) %>% census.format() -> ag25_34  
aa<-"ag35_64"; census.form(ag35_64,df.integer=ag35_64, aa) %>% census.format() -> ag35_64  
aa<-"ag65_"; census.form(ag65over,df.integer=ag65over, aa) %>% census.format() -> ag65_  
list(ag16_24[,-2],ag25_34[,-2],ag35_64[,-2],ag65_[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> age

aa<-"gender_m"; census.form(gender_m,df.integer=gender_m, aa) %>% census.format() -> gender_m  
aa<-"gender_f"; census.form(gender_f,df.integer=gender_f, aa) %>% census.format() -> gender_f  
list(gender_m[,-2],gender_f[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> gender

aa<-"car_0"; census.form(carsNo,df.integer=carsNo, aa) %>% census.format() -> car_0  
aa<-"car_1"; census.form(car_1,df.integer=car_1, aa) %>% census.format() -> car_1  
aa<-"car_2"; census.form(cars_2,df.integer=cars_2, aa) %>% census.format() -> car_2  
aa<-"car_3"; census.form(Carsor3,df.integer=Carsor3, aa) %>% census.format() -> car_3  
list(car_0[,-2],car_1[,-2],car_2[,-2],car_3[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> cars

aa<-"household_A"; census.form(Household_A,df.integer=Household_A, aa) %>% census.format() -> household_A
aa<-"household_B"; census.form(Household_B,df.integer=Household_B, aa) %>% census.format() -> household_B
aa<-"household_C"; census.form(Household_C,df.integer=Household_C, aa) %>% census.format() -> household_C
aa<-"household_D"; census.form(Household_D,df.integer=Household_D, aa) %>% census.format() -> household_D
aa<-"household_E"; census.form(Household_E,df.integer=Household_E, aa) %>% census.format() -> household_E
list(household_A[,-2],household_B[,-2],household_C[,-2],household_D[,-2],household_E[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> hsehld

aa<-"Europe"; census.form(Europe1,df.integer=Europe1, aa) %>% census.format() -> Europe
aa<-"NonEurope"; census.form(NonEurope1,df.integer=NonEurope1, aa) %>% census.format() -> NonEurope
list(Europe[,-2],NonEurope[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> ethnic

aa<-"NoChild"; census.form(NoChild1,df.integer=NoChild1, aa) %>% census.format() -> NoChild
aa<-"YesChild"; census.form(YesChild1,df.integer=YesChild1, aa) %>% census.format() -> YesChild
list(NoChild[,-2],YesChild[,-2]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> child

#k <- 2 # nrow(mode)# create census data in sms-dimitris
for(i in 1:nrow(mode)){liam<-max(as.numeric(rowSums(mode[i,2:ncol(mode)],na.rm=T)), as.numeric(rowSums(income[i,2:ncol(income)],na.rm=T)), as.numeric(rowSums(age[i,2:ncol(age)],na.rm=T)), 
  as.numeric(rowSums(gender[i,2:ncol(gender)],na.rm=T)), as.numeric(rowSums(cars[i,2:ncol(cars)],na.rm=T)), as.numeric(rowSums(hsehld[i,2:ncol(hsehld)],na.rm=T)), as.numeric(rowSums(ethnic[i,2:ncol(ethnic)],na.rm=T)), as.numeric(rowSums(child[i,2:ncol(child)],na.rm=T))); 
    kk <- 2;aa<-(liam-as.numeric(rowSums(mode[i,2:ncol(mode)],na.rm=T))); while(!is.na(aa) & aa >= 1){if(kk>=ncol(mode)+1){kk<-2}else{if(mode[i,kk]!=0 & (!is.na(mode[i,kk]))){mode[i,kk]<-mode[i,kk]+1; kk<-kk+1; aa<-aa-1}else{kk<-kk+1}}}; mode[is.na(mode)] <- 0;
      mm <- 2;bb<-(liam-as.numeric(rowSums(income[i,2:ncol(income)],na.rm=T))); while(!is.na(bb) & bb >= 1){if(mm>=ncol(income)+1){mm<-2}else{if(income[i,mm]!=0 & (!is.na(income[i,mm]))){income[i,mm]<-income[i,mm]+1; mm<-mm+1; bb<-bb-1}else{mm<-mm+1}}}; income[is.na(income)] <- 0;
        nn <- 2;cc<-(liam-as.numeric(rowSums(age[i,2:ncol(age)],na.rm=T))); while(!is.na(cc) & cc >= 1){if(nn>=ncol(age)+1){nn<-2}else{if(age[i,nn]!=0 & (!is.na(age[i,nn]))){age[i,nn]<-age[i,nn]+1; nn<-nn+1; cc<-cc-1}else{nn<-nn+1}}}; age[is.na(age)] <- 0;
          oo <- 2;dd<-(liam-as.numeric(rowSums(gender[i,2:ncol(gender)],na.rm=T))); while(!is.na(dd) & dd >= 1){if(oo>=ncol(gender)+1){oo<-2}else{if(gender[i,oo]!=0 & (!is.na(gender[i,oo]))){gender[i,oo]<-gender[i,oo]+1; oo<-oo+1; dd<-dd-1}else{oo<-oo+1}}}; gender[is.na(gender)] <- 0;
            pp <- 2;ee<-(liam-as.numeric(rowSums(cars[i,2:ncol(cars)],na.rm=T))); while(!is.na(ee) & ee >= 1){if(pp>=ncol(cars)+1){pp<-2}else{if(cars[i,pp]!=0 & (!is.na(cars[i,pp]))){cars[i,pp]<-cars[i,pp]+1; pp<-pp+1; ee<-ee-1}else{pp<-pp+1}}}; cars[is.na(cars)] <- 0;
              rr <- 2;ff<-(liam-as.numeric(rowSums(hsehld[i,2:ncol(hsehld)],na.rm=T))); while(!is.na(ff) & ff >= 1){if(rr>=ncol(hsehld)+1){rr<-2}else{if(hsehld[i,rr]!=0 & (!is.na(hsehld[i,rr]))){hsehld[i,rr]<-hsehld[i,rr]+1; rr<-rr+1; ff<-ff-1}else{rr<-rr+1}}}; hsehld[is.na(hsehld)] <- 0;
                tt <- 2;hh<-(liam-as.numeric(rowSums(ethnic[i,2:ncol(ethnic)],na.rm=T))); while(!is.na(hh) & hh >= 1){if(tt>=ncol(ethnic)+1){tt<-2}else{if(ethnic[i,tt]!=0 & (!is.na(ethnic[i,tt]))){ethnic[i,tt]<-ethnic[i,tt]+1; tt<-tt+1; hh<-hh-1}else{tt<-tt+1}}}; ethnic[is.na(ethnic)] <- 0;
                  ss <- 2;gg<-(liam-as.numeric(rowSums(child[i,2:ncol(child)],na.rm=T))); while(!is.na(gg) & gg >= 1){if(ss>=ncol(child)+1){ss<-2}else{if(child[i,ss]!=0 & (!is.na(child[i,ss]))){child[i,ss]<-child[i,ss]+1; ss<-ss+1; gg<-gg-1}else{ss<-ss+1}}}; child[is.na(child)]<-0  }
####
## join categories of variables  
aaa <- mode; aaa$population <- NA
bbb <- as.data.frame(rowSums(mode[,c(2:ncol(mode))],na.rm=T))
for(i in 1:nrow(bbb)){aaa[i,174] <- bbb[i,1]}
mode <- aaa[,c(1,174,2:173)]; 
list(mode, income, age, gender, cars, hsehld, ethnic, child) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="areaid"), .) -> aggreg
census <- aggreg

#write.csv(census,"/nfs/a237/gyeao/results/comb-optim/sms_stoc_cens_nrts_v6non/census.csv",quote=TRUE,na="NA",row.names=TRUE)

### create individual-level data ###                   
#### read NRTS indi-level data ### randomly fill missing values till Amelia comes ##############
ind_data <- read.csv("results/amelia1/ind_nrts_yh.csv",header=T,stringsAsFactors=T) #ind_data_NA <- ind_data[rowSums(is.na(ind_data[,c(4:6)])) > 0,]# check
ind_data <- convert.magic(ind_data,c('n','n','n','c','c','c','c','c','c','c','c','c','c'))
## deal with Na's in res, orig and dest #######
for(i in 1:nrow(ind_data)){if((is.na(ind_data[i,'Residence_PC']))&(!is.na(ind_data[i,'Orig_PC']))&(!is.na(ind_data[i,'Dest_PC']))){ind_data[i,'Residence_PC']<-ind_data[i,'Orig_PC']}}
for(i in 1:nrow(ind_data)){if((is.na(ind_data[i,'Orig_PC']))&(!is.na(ind_data[i,'Residence_PC']))&(!is.na(ind_data[i,'Dest_PC']))){ind_data[i,'Orig_PC']<-ind_data[i,'Residence_PC']}}
for(i in 1:nrow(ind_data)){if((is.na(ind_data[i,'Dest_PC']))&(!is.na(ind_data[i,'Residence_PC']))&(!is.na(ind_data[i,'Orig_PC']))){ind_data[i,'Dest_PC']<-ind_data[i,'Residence_PC']}}

ind_data <- ind_data[rowSums(is.na(ind_data[,4:6]))==0,] # delete rows with only one of res, orig, dest # below fill other missing variables random

# remove all rows with NA in individual data infill is in script 'stoc_cens_nrts_v4.R'
storage <- ind_data
  ind_data <- na.omit(ind_data)
    msng.rows <- nrow(storage)-nrow(ind_data)
      msng.diff <- setdiff(storage,ind_data)                
    
ind_data$direction <- NA # next decide out vs in journeys and float or home
for(i in 1:nrow(ind_data)){if((ind_data[i,'Residence_PC']==ind_data[i,'Orig_PC'])&(ind_data[i,'Residence_PC']!=ind_data[i,'Dest_PC'])){ind_data[i,'direction']<-'out'}}
for(i in 1:nrow(ind_data)){if((ind_data[i,'Residence_PC']==ind_data[i,'Dest_PC'])&(ind_data[i,'Residence_PC']!=ind_data[i,'Orig_PC'])){ind_data[i,'direction']<-'in'}}
for(i in 1:nrow(ind_data)){if((ind_data[i,'Residence_PC']==ind_data[i,'Dest_PC'])&(ind_data[i,'Residence_PC']==ind_data[i,'Orig_PC'])){ind_data[i,'direction']<-'home'}}
for(i in 1:nrow(ind_data)){if((ind_data[i,'Residence_PC']!=ind_data[i,'Dest_PC'])&(ind_data[i,'Residence_PC']!=ind_data[i,'Orig_PC'])){ind_data[i,'direction']<-'float'}}

## next reconfigure (in and float) so journeys reconcile with Census which assumes each journey is return journey (i.e in and out)
for(i in 1:nrow(ind_data)){if((ind_data[i,'Residence_PC']==ind_data[i,'Dest_PC'])&(ind_data[i,'Residence_PC']!=ind_data[i,'Orig_PC'])){oo<-ind_data[i,'Orig_PC']; dd<-ind_data[i,'Dest_PC']; ind_data[i,'Orig_PC']<-dd; ind_data[i,'Dest_PC']<-oo}}
#for(i in 1:nrow(ind_data)){if((ind_data[i,'Residence_PC']!=ind_data[i,'Dest_PC'])&(ind_data[i,'Residence_PC']!=ind_data[i,'Orig_PC'])){ind_data[i,'Orig_PC']<-ind_data[i,'Residence_PC']}}
##
drops1 <- c('OriginPurpose','DestinationPurpose','direction')
tests <- ind_data[,!(names(ind_data) %in% drops1)]
tests$j_leg <- ''
tests <- convert.magic(tests,c('n','c','c','c','c','c','c','c','c','c','c','c')) ## tests <- data.frame(lapply(tests, as.character), stringsAsFactors=FALSE)

for(i in 1:nrow(tests)){if(tests[i,'Residence_PC']==tests[i,'Orig_PC']){tests[i,'j_leg']<-'out'}else{} }# outward leg of journey
for(i in 1:nrow(tests)){if(tests[i,'Residence_PC']==tests[i,'Dest_PC']){tests[i,'j_leg']<-'in'}else{} }# return leg of journey
for(i in 1:nrow(tests)){if((tests[i,'Residence_PC']!=tests[i,'Orig_PC'])&(tests[i,'Residence_PC']!=tests[i,'Dest_PC'])){tests[i,'j_leg']<-'float_1'}else{} } # floaters going elsewhere 
for(i in 1:nrow(tests)){if((tests[i,'Residence_PC']==tests[i,'Orig_PC'])&(tests[i,'Residence_PC']==tests[i,'Dest_PC'])){tests[i,'j_leg']<-'close_h'}else{} } # drop off delivery rounds

tests1 <- tests[((tests$j_leg=='out')|(tests$j_leg=='close_h')),]
ind_data <- tests1[,-which(names(tests1) %in% "j_leg")]
###

vec <- as.character(origin[["com_sect"]]) # presence or absence of as.character doesn't seem to make any difference!
dada2 <- ind_data[(with(ind_data, which(apply(ind_data, 1, function(r) any(r %in% vec))))), ] ## #dada1 <- ind_data[-(with(ind_data, which(apply(ind_data, 1, function(r) any(r %in% vec))))), ] ## retains or removes rows which contain any of the values in vector!!

dada2 <- subset(dada2, Residence_PC %in% vec) ## apolinary 
dada2 <- subset(dada2, Orig_PC %in% vec) ## law menkiti
dada2 <- subset(dada2, Dest_PC %in% vec) ## mathias odita

####### includes the purpose of travel commute by train or not ########################################################################
dada2 <- convert.magic(dada2,c('n','c','c','c','c','c','c','c','c','c','c'))
purpose <- convert.magic(purpose,c('n','c'))

papa2 <- left_join(dada2,purpose, by=c("Ind_ID"="Ind_ID"))
individuals <- papa2

individuals[individuals=="NoChild1"]<-"NoChild"
individuals[individuals=="YesChild1"]<-"YesChild"
individuals[individuals=="NonEuropean1"]<-"NonEurope"
individuals[individuals=="European1"]<-"Europe"
individuals[individuals=="No_cars"]<-"car_0"
individuals[individuals=="1_car"]<-"car_1"
individuals[individuals=="2_cars"]<-"car_2"
individuals[individuals=="3ovr_cars"]<-"car_3"
individuals[individuals=="Age16_24"]<-"ag16_24"
individuals[individuals=="Age25_34"]<-"ag25_34"
individuals[individuals=="Age35-64"]<-"ag35_64"
individuals[individuals=="over_65"]<-"ag65_"

individuals <- individuals[,c(2,12,3:11,1)]

cc <- merge(individuals, area.sect, by.x='Residence_PC', by.y='com_sect', all=F); cc$Residence_PC <- cc$postarea; cc <- cc[,-13]
cc <- merge(cc, area.sect, by.x='Orig_PC', by.y='com_sect', all=F); cc$Orig_PC <- cc$postarea; cc <- cc[,-13]
cc <- merge(cc, area.sect, by.x='Dest_PC', by.y='com_sect', all=F); cc$Dest_PC <- cc$postarea; cc <- cc[,-13]
dd <- cc[,c(3:1,4:12)]
individual <- dd
ind_data_area <- individual
## flow interaction - append origin and destination 
for(pp in 4:(ncol(ind_data_area)-1)){for(qq in 1:nrow(ind_data_area)){ind_data_area[qq,pp] <- str_c(paste(ind_data_area[qq,2],'-',sep=''),ind_data_area[qq,pp],paste('-',ind_data_area[qq,3],sep=''))}}
indivs <- ind_data_area[,-c(2:3,12)]

#ggg <- as.data.frame(names(census))

# survey seed data structure in sms-dimitris
survey_ref <- data.frame(matrix(ncol = 1, nrow = nrow(indivs))) # create empty dataframe
  for(i in 2:ncol(indivs)){cat <- model.matrix(~ indivs[,i] - 1); survey_ref <- cbind(cat,survey_ref)} # re-modelling matrices
    survey_model_matrix <- survey_ref[,-ncol(survey_ref)] # remove nuisance row created with empty dataframe
      names(survey_model_matrix) <- substring(names(survey_model_matrix), 12) # start from 17th character
        survey_model_matrix$Residence_PC <- indivs$Residence_PC; survey_model_matrix <- survey_model_matrix[,c(ncol(survey_model_matrix),1:(ncol(survey_model_matrix)-1) )]
            survey <- survey_model_matrix
              survey <- survey[,-1]; survey <- setDT(survey, keep.rownames = TRUE)[]
                colnames(survey)[1] <- "pid"; survey <- as.data.frame(survey)
###
## difference in dataframes #### create columns for cats and attri missing in ind level data - # sms-dimitris
temporal <- setdiff(names(census[,c(3:ncol(census))]),names(survey[,c(2:ncol(survey))]))                
  survey[,temporal] <- 0                 
    match.ind <- intersect(names(survey[,c(2:ncol(survey))]), names(census[,c(3:ncol(census))])) 
      survey_v2 <- survey[ ,match.ind] # remove individuals that don't have corresponding matches in census aggregate
        survey_v2 <- survey_v2[, names(census[,c(3:ncol(census))])] 
          survey_v2$pid <- survey$pid  
            survey_v2 <- survey_v2[,c(ncol(survey_v2),1:(ncol(survey_v2)-1))]
              survey <- survey_v2

#write.csv(survey,"/nfs/a237/gyeao/results/comb-optim/sms_stoc_cens_nrts_v6non/survey.csv",quote=TRUE,na="NA",row.names=TRUE)

## adj ustments to create extra populace to tally census
## store<-survey; survey <- store
length <- nrow(survey)
for(i in 1:length(temporal)){
  for(j in 1:ncol(survey)){ 
    if(names(survey)[j]==temporal[i]){survey[length+i,j]<-1}else{survey[length+i,j]<-0}  }}
for(i in 1:length(temporal)){survey[length+i,1]<-as.character(paste(length+i,sep='')) }             

# create lexicon 
in.lexicon <- createLexicon()
for(i in 3:length(names(census))){in.lexicon <- addDataAssociation(in.lexicon, c(paste(colnames(census)[i]), paste(colnames(census)[i])))}
############
      
mysms <- new("microsimulation", iterations = 500, census = census, panel = survey, lexicon = in.lexicon)
  myseed <- 1800                
    try05 <- run_serial(insms = mysms) 
      for(i in 1:nrow(census)){as.data.frame(assign(paste("z",census[i,1],sep=""), try05[[i]])['selection']) %>% write.csv(paste("/nfs/a237/gyeao/results/comb-optim/sms_stoc_cens_nrts_v6non/","z_",census[i,1],".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)}
        write.table(try05$selection, "try05.csv", sep=",")

# plotting etc      
#for(fk in 2:6){assign(paste("distr",fk,sep=""), read.csv(paste("results/mipf/adjusted data/output",fk,".csv",sep=""),header=T,stringsAsFactors=FALSE))}  
#list(distr2,distr3,distr4,distr5,distr6) %>%  Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="X"), .) -> dist ; dist <- dist[,-1]
#names(dist) <- c('2-Constr','3-Constr','4-Constr','5-Constr','6-Constr') #,'7-Constr','8-Constr')  ## '1-Constr',
#w.plot <- melt(dist) ; names(w.plot) <- c('CONSTRAINTS','Total.Absolute.Error')
#cbbPalette <- c("darkgrey","#56B4E9","red","#009E73","#D55E00")# ,"#0072B2")#,"#000000","#999999") ## "#F0E442",
#lineSizes <- c(2.5,2.5,2.5,2.5,2.5) # ,2.5)  #c(3.5,3,2.5,2,1.5,1)#,1,0) # c(8,7,6,5,4,3,2,1)
#p <- ggplot(w.plot, aes(x=Total.Absolute.Error)) + geom_density(aes(colour = CONSTRAINTS, group = CONSTRAINTS, size = CONSTRAINTS)) + scale_color_manual(values=cbbPalette) + scale_size_manual(values = lineSizes) # + coord_trans(y = "log10")# gooooood
##p <- ggplot(aes(x=value, colour=variable), data=w.plot) + geom_density() ## also look at density(dist$X3) # kernel density plots http://www.statmethods.net/graphs/density.html  ## plot(d) # plots the results
#grid.newpage();grid.draw(p)

#diff <- census; for(ip in 1:nrow(sim)){for(jp in 3:ncol(sim)){diff[ip,jp]<-(abs(sim[ip,jp]-census[ip,jp])) }}
#  diff <- diff[,-2]
#    total.diff <- as.numeric(colSums(as.data.frame(colSums(diff[,-1]))))   
#      distrib[m,n] <- total.diff                       

