# program to read the LEENON ticketing data, 
# re-configure LENNON variables for comparison with NRTS-Census
# perform detreministic spatial micro-simulation to create the final representative simulated rail passengers
# for linux swop ############# replace '/nfs/a237/gyeao' with 's:/gyeao'
##########
getwd() #confirm working directory
setwd("/nfs/a237/gyeao") # s:/gyeao  ### M:/temp_no_z_s
rm(list=ls()) 
##
#install.packages(c("dplyr", "mipfp"),repos="http://cran.r-project.org")
#
#install.packages("rgdal") # for reading shapefiles
#install.packages("dplyr") # for left_join etc
#install.packages("mipfp")
#install.packages("reshape2")
#install.packages("ggplot2")  ## for full_join 
#install.packages("grid")  ## for full_join 
#install.packages("gridExtra") 
#install.packages("plyr")
#install.packages("magrittr")
#install.packages("stringr") ## used for filter str
#install.packages("data.table")

library("rgdal")
library("dplyr")
library(mipfp)
library(reshape2)
library(ggplot2)  ## for full_join 
library(grid)  ## for full_join 
library(gridExtra) 
library(plyr)
library(magrittr)  ## for piping 
library(stringr)  ## for piping 
library(data.table)

##
#install.packages("plyr", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
#install.packages("dplyr", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/") # for left_join etc
#install.packages("rgdal", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/") # for reading shapefiles
#install.packages("mipfp", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
#install.packages("reshape2", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
#install.packages("ggplot2", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")  ## for full_join 
#install.packages("grid", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")  ## for full_join 
#install.packages("gridExtra", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/") 
#install.packages("magrittr", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")
#install.packages("stringr", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/") 
#install.packages("data.table", lib="/nfs/a237/gyeao/RLibs", repos="http://cran.rstudio.com/")

#library(plyr, lib.loc="/nfs/a237/gyeao/RLibs")
#library(dplyr, lib.loc="/nfs/a237/gyeao/RLibs")
#library(rgdal, lib.loc="/nfs/a237/gyeao/RLibs")
#library(mipfp, lib.loc="/nfs/a237/gyeao/RLibs")
#library(reshape2, lib.loc="/nfs/a237/gyeao/RLibs")
#library(ggplot2, lib.loc="/nfs/a237/gyeao/RLibs")  ## for full_join 
#library(grid, lib.loc="/nfs/a237/gyeao/RLibs")  ## for full_join 
#library(gridExtra, lib.loc="/nfs/a237/gyeao/RLibs") 
#library(magrittr, lib.loc="/nfs/a237/gyeao/RLibs")  ## for piping 
#library(stringr, lib.loc="/nfs/a237/gyeao/RLibs")
#library(data.table, lib.loc="/nfs/a237/gyeao/RLibs")
#######################################
convert.magic<-function(obj,types){for(i in 1:length(obj)){FUN<-switch(types[i],c=as.character,n=as.numeric,f=as.factor);obj[,i]<-FUN(obj[,i])};obj}
##
lennon <- read.csv("data_atoc/ATOC/LENNON-Eusebio-170216 shortened version.csv",header=T,stringsAsFactors=F)  
for(i in 8:12){lennon[,i] <- as.numeric(gsub(",","",lennon[,i]))}  # check lennon <- lennon[1:100,]
lennon <- lennon[grepl("2015/P13", lennon$Period.of.Settlement),]
lennon <- convert.magic(lennon,c('c','c','c','c','c','c','c','n','n','n','n','n','c','c','c','c','c','c'))

####### read in one shapefile from Arcmap #
temp <- readOGR(dsn=path.expand("/nfs/a237/gyeao/analysis_smicrosimulation/nrts_census/results/ticket_nrts_census"), layer="station_nlcs")
temp <- as.data.frame(temp); temp <- temp[,c(3,5:8)]
temp <- convert.magic(temp,c('c','c','c','c','c'))

for(i in 1:nrow(temp)){
  if(temp[i,1]=='Pontefract Monkhill'|temp[i,1]=='Pontefract Baghill'){temp[i,2]='268'}else{
    if(temp[i,1]==('Bradford Interchange')){temp[i,2]='424'}else{
      if(temp[i,1]==('Wakefield Kirkgate')){temp[i,2]='444'}else{}}}  }
temp <- temp[!duplicated(temp[,c('NLC')]),]

## process aggregate lennon target data for train stations in west yorkshire
#lennon_2 <- merge(lennon, temp, by.x = "Origin.Code", by.y = "NLC", all.x = T, all.y = F) 

vec <- as.character(temp[['NLC']]) # catherine odiari
  vecc <- as.character(temp[['CRS_Code']]) 
    lennon <- subset(lennon, Origin.Code %in% vec) ## apolinary and law menkiti
      lennon <- subset(lennon, Destination.Code %in% vec) ## mathias odita
        lennon$id  <- row.names(lennon)
lennon <- left_join(lennon,temp, by=c("Origin.Code"="NLC"))
lennon <- left_join(lennon,temp, by=c("Destination.Code"="NLC"))

lennon <- lennon[,c('Period.of.Settlement','NAME.x','CRS_Code.x','Eastings.x','Northings.x','NAME.y','CRS_Code.y','Eastings.y','Northings.y', 
                    'Route.Code','Route.Desc','Issues....','Journeys....','Ticket.Miles....','Net.Receipt.Sterling....',
                      'Gross.Receipt.Sterling....','Product.Code','Product.Desc','Product.Level.1.Code','Product.Level.1.Desc','Ticket.Status.Code','Ticket.Status.Desc', 'id')]
names(lennon) <- c('Period.of.Settlement','O.Name','O.Code','O.Eastings','O.Northings','D.Name','D.Code','D.Eastings','D.Northings', 
                      'Route.Code','Route.Desc','Issues','Journeys','Ticket.Miles','Net.Receipt.Sterling',
                        'Gross.Receipt.Sterling','Product.Code','Product.Desc','Product.Level.1.Code','Product.Level.1.Desc','Ticket.Status.Code','Ticket.Status.Desc','id')
lennon$Ticket.class <- substr(lennon$Product.Code, start = 1, stop = 1) # class of ticket
vec3 <- c('001 PUBLIC CHILD', '016 PRIVILEGE CHILD', '019 DISCOUNT CHILD', '2ZTX', '2ZTZ')## #dada1 <- ind_data[-(with(ind_data, which(apply(ind_data, 1, function(r) any(r %in% vec))))), ] ## retains or removes rows with values in vec3
lennon <- lennon[(-with(lennon, which(apply(lennon, 1, function(r) any(r %in% vec3))))), ] ## removes 'child', replacement tickets to match census >16yrs, keeps 'young person' 16-25

### extract 18 lennon ticket product code for linking to nrts 41,42 part
for(i in 1:nrow(lennon)){ # sort out passenger ticket type
  if(lennon$Product.Code[i]=='1AAA' | lennon$Product.Code[i]=='2AAA'){lennon[i,'Ticket.TypeID'] <-'1'}else{ 
    if(lennon$Product.Code[i]=='1BAF' | lennon$Product.Code[i]=='2BAF'){lennon[i,'Ticket.TypeID'] <-'2'}else{ 
      if(strsplit(lennon$Product.Desc[i]," ")[[1]][1]=='SAVER'){lennon[i,'Ticket.TypeID'] <-'3'}else{ 
        if(lennon$Product.Code[i]=='2ADA'){lennon[i,'Ticket.TypeID'] <- '4'}else{ 
          if(lennon$Product.Code[i]=='2BDY'){lennon[i,'Ticket.TypeID'] <- '5'}else{ 
            #if(lennon$Product.Code[i]=='one day travel card'){lennon[i,'Ticket.TypeID'] <- '6'}else{ 
              if(lennon$Product.Code[i]=='1MQA' | lennon$Product.Code[i]=='2MQA'){lennon[i,'Ticket.TypeID'] <- '7'}else{ 
                if(lennon$Product.Code[i]=='1MTA' | lennon$Product.Code[i]=='2MTA'){lennon[i,'Ticket.TypeID'] <- '8'}else{ 
                  if(lennon$Product.Code[i]=='2MTW'){lennon[i,'Ticket.TypeID'] <- '9'}else{ 
                    if(lennon$Product.Code[i]=='2MTL' | lennon$Product.Code[i]=='2MTH' | lennon$Product.Code[i]=='2MTF'){lennon[i,'Ticket.TypeID'] <- '10'}else{}}}}}}}}} }
for(i in 1:nrow(lennon)){  # sort out passenger category
  if(lennon$Ticket.Status.Code[i] %in% c(3)){lennon[i,'Passenger.Cat'] <-'1'}else{ 
    if(lennon$Ticket.Status.Code[i] %in% c(63,64,141,147,185)){lennon[i,'Passenger.Cat'] <-'2'}else{ 
      if(lennon$Ticket.Status.Code[i] %in% c(6,188)){lennon[i,'Passenger.Cat'] <-'3'}else{ 
        if(lennon$Ticket.Status.Code[i] %in% c(15,18,24,27,28,39,44,47,51,52,57,70,73,98,104)){lennon[i,'Passenger.Cat'] <-'4'}else{ 
          if(lennon$Ticket.Status.Code[i] %in% c(12,13,161)){lennon[i,'Passenger.Cat'] <-'5'}else{ 
            if(lennon$Ticket.Status.Code[i] %in% c(0)){lennon[i,'Passenger.Cat'] <-'6'}else{ 
              if(lennon$Ticket.Status.Code[i] %in% c(9,10,42,60,61)){lennon[i,'Passenger.Cat'] <-'7'}else{}}}}}}}}
aaa <- lennon # checketr  lennon <- aaa 
lennon <- lennon[, -c(1:2,4:6,8:12,14:22)]  ;  rownames(lennon)<-lennon$id;  lennon <- lennon[, c(1:2,5:7,3)]   
lennon$Journeys <- as.integer(lennon$Journeys) ;  lennon <- lennon[lennon$Journeys > 0,]                    
lennon <- lennon[rep(row.names(lennon), lennon$Journeys), 1:5]                             
##
bbb <- unique(lennon) # checker
# make up 7 missing with normal passenegers
vec1 <- setdiff(vecc,lennon$O.Code)
vec2 <- setdiff(vecc,lennon$D.Code )
vec3 <- setdiff(vec2,vec1); mm<-length(vec3)
len <- nrow(lennon)
for(i in 1:max(length(vec1),length(vec2))){if(i<=min(length(vec1),length(vec2))){
  lennon[(i+len),1]<-vec1[i];lennon[(i+len),2]<-vec2[i];lennon[(i+len),3]<-'2';lennon[(i+len),4]<-'1';lennon[(i+len),5]<-'6'}else{
    lennon[(i+len),1]<-vec3[mm];lennon[(i+len),2]<-vec2[i];lennon[(i+len),3]<-'2';lennon[(i+len),4]<-'1';lennon[(i+len),5]<-'6';mm<-(mm-1)}}
      lennon <- convert.magic(lennon,c('c','c','c','c','c'))
        lennon <- na.omit(lennon) # remove any spurious na's
#### 
ccc <- unique(lennon)
## process seed data nrts.census micro-pop for train stations in west yorkshire
nrts.census <- read.csv("/nfs/a237/gyeao/results/sim.pop.LS1/sim.pop.zone.4.csv",header=T,stringsAsFactors=F); nrts.census <- nrts.census[,-1]
nrts.raw <- read.csv("analysis_smicrosimulation/nrts_census/results/Ind_level_nrts/nrts_with_pc.csv",header=T,stringsAsFactors=F)

nrts.raw[nrts.raw=="No_cars"]<-"car_0"
nrts.raw[nrts.raw=="1_car"]<-"car_1"
nrts.raw[nrts.raw=="2_cars"]<-"car_2"
nrts.raw[nrts.raw=="3ovr_cars"]<-"car_3"
nrts.raw[nrts.raw=="Age35-64"]<-"Age35_64"
nrts.raw[nrts.raw=="over_65"]<-"Age65_"
nrts.raw[nrts.raw=="NonEuropean1"]<-"NonEuropean"; nrts.raw[nrts.raw=="European1"]<-"European"
nrts.raw[nrts.raw=="YesChild1"]<-"Child_Yes"; nrts.raw[nrts.raw=="NoChild1"]<-"Child_No"

nrts.cens <- nrts.census
nrts <- read.csv("data_nrts/NRTS/150810_Yorkshire and Humberside NRTS dataset.csv",header=T,stringsAsFactors=FALSE)
  nrts$Ind_ID <- nrts[[1]] # nrts$'..UniqueSerialNumber' 
    nrts <- subset(nrts, OriginStationNLC %in% vec) ## apolinary and law menkiti
      nrts <- subset(nrts, DestStationNLC %in% vec) ## mathias odita
original.nrts <- nrts
       temp.origin <- temp; temp.origin$OriginStationNLC <- temp$NLC;  colnames(temp.origin)[names(temp.origin)=="CRS_Code"] <- "O.Code"
        temp.dest <- temp; temp.dest$DestStationNLC <- temp$NLC; colnames(temp.dest)[names(temp.dest)=="CRS_Code"] <- "D.Code"
          temp.origin <- convert.magic(temp.origin,c('c','c','c','c','c','c')); temp.dest <- convert.magic(temp.dest,c('c','c','c','c','c','c'))
            nrts$OriginStationNLC <- as.character(nrts$OriginStationNLC); nrts$DestStationNLC <- as.character(nrts$DestStationNLC)
              list(nrts,temp.origin) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="OriginStationNLC"), .) -> nrts
                list(nrts,temp.dest) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="DestStationNLC"), .) -> nrts
for(i in 1:nrow(nrts)){ # sort out passenger ticket type
  if(nrts$JourneyTypeID[i]=='1' | nrts$TicketTypeID[i]=='1'){nrts[i,'Ticket.TypeID2'] <-'1'}else{ 
    if(nrts$JourneyTypeID[i]=='2' | (nrts$JourneyTypeID[i]=='2') | nrts$TicketTypeID[i]=='2'){nrts[i,'Ticket.TypeID2'] <-'2'}else{ 
      if(nrts$TicketTypeID[i]=='3'){nrts[i,'Ticket.TypeID2'] <-'3'}else{ 
        if(nrts$TicketTypeID[i]=='4'){nrts[i,'Ticket.TypeID2'] <- '4'}else{ 
          if(nrts$TicketTypeID[i]=='5'){nrts[i,'Ticket.TypeID2'] <- '5'}else{ 
            if(nrts$TicketTypeID[i]=='6'){nrts[i,'Ticket.TypeID2'] <- '6'}else{ 
              if(nrts$SeasonTicketType[i]=='1'){nrts[i,'Ticket.TypeID2'] <- '7'}else{ 
                if(nrts$SeasonTicketType[i]=='2'){nrts[i,'Ticket.TypeID2'] <- '8'}else{ 
                  if(nrts$SeasonTicketType[i]=='3'){nrts[i,'Ticket.TypeID2'] <- '9'}else{ 
                    if(nrts$SeasonTicketType[i]=='4' | nrts$SeasonTicketType[i]=='7'){nrts[i,'Ticket.TypeID2'] <- '10'}else{}}}}}}}}}  }}
for(i in 1:nrow(nrts)){   # sort out passenger category  
  if(nrts$AgeRangeID[i] %in% c(2,3)){nrts[i,'Passenger.Cat'] <-'1'}else{ 
    if((nrts$Disability[i] %in% c(1)) | (nrts$SeasonTicketType[i] %in% c(11))){nrts[i,'Passenger.Cat'] <-'2'}else{ 
      if((nrts$AgeRangeID[i] %in% c(8,9)) | (nrts$RailcardTypeID[i] %in% c(3))){nrts[i,'Passenger.Cat'] <-'3'}else{ 
          if(nrts$SeasonTicketType[i] %in% c(12)){nrts[i,'Passenger.Cat'] <-'5'}else{ 
            if((nrts$AgeRangeID[i] %in% c(4,5,6,7,8,9)) & (nrts$Disability[i] %in% c(2)) & (nrts$RailcardTypeID[i] %in% c(1,2,3,5)) & (nrts$SeasonTicketType[i] %in% c(1:9))){nrts[i,'Passenger.Cat'] <-'6'}else{ 
              if(nrts$RailcardTypeID[i] %in% c(4)){nrts[i,'Passenger.Cat'] <-'7'}else{nrts[i,'Passenger.Cat'] <-'4'}}}}}}}
list(nrts.census,nrts) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="Ind_ID"), .) -> nrts.census
  f <- c('O.Code','D.Code','TicketClass','Ticket.TypeID2','Passenger.Cat','Ind_ID')
    nrts.rrr <- names(nrts.census)[(names(nrts.census) %in% f)]; 
      df.subset <- nrts.census[, nrts.rrr]; 
        names(df.subset)[names(df.subset)=="Ticket.TypeID2"] <- "Ticket.TypeID"   
          nrts.census <- df.subset[,c(3:4,2,5,6,1)]; names(nrts.census)[names(nrts.census)=="TicketClass"] <- "Ticket.class" 
            nrts.census <- na.omit(nrts.census) ## remove any spurious na's
##
lennon.copy <- lennon            
match.ind <- intersect(names(nrts.census[,-ncol(nrts.census)]),names(lennon)) 
  lennon <- lennon[ ,match.ind] # remove individuals that don't have corresponding matches in census aggregate
    lennon <- lennon[, names(nrts.census[,-ncol(nrts.census)])] 
      for(k in 1:3){ # exigencies of if one dataset contains an outlier station not in WY
        for(j in 1:ncol(lennon)){                  
          if(length(unique(lennon[[j]]))>=length(unique(nrts.census[[j]]))){
            vec_tmp<-as.character(nrts.census[[j]]); lennon<-subset(lennon, lennon[[j]] %in% vec_tmp)}else{ 
              vec_tmp<-as.character(lennon[[j]]); nrts.census<-subset(nrts.census, nrts.census[[j]] %in% vec_tmp)}   }}

ddd <- unique(lennon)
  eee <- unique(lennon[,-3])
    fff <- unique(nrts.census); fff1 <- unique(fff[,c(1:2,4:5)])
## deterministic spatial micro-sim lennon vs nrts.census
seed.df <- nrts.census[,-3]
  seed.df <- as.data.frame(seed.df)
    seed.df <- seed.df[!duplicated(seed.df), ]  ## this might have saved the day IJ
      seed.table <- table(seed.df) #+ 0.00001

ggg <- unique(nrts.census)      
              
store <- lennon; lennon <- lennon[,-3]
true.table <- table(lennon) #+ 0.00001                                         
  tgt.v1 <- apply(true.table, c(1:ncol(lennon)), sum)
    tgt.l.dims <- list(c(1:ncol(lennon)))
      tgt.data <- list(tgt.v1)

# rm(list=setdiff(ls(), c("seed.table","tgt.l.dims","tgt.data"))  )      
mipf <- Estimate(seed=seed.table, target.list=tgt.l.dims, target.data=tgt.data)
x <- mipf$p.hat; x.df <- as.data.frame(x); 

# remove all objects except x.df ## free up allocatable memory
#rm(list=setdiff(ls(), c("lennon","x.df"))  )
  #x.df$Freq <- (x.df$Freq)*nrow(lennon); x.df$Freq <- round(x.df$Freq,0); 
  x.df$Freq <- (x.df$Freq)*900849; x.df$Freq <- round(x.df$Freq,0); 
    x.df<-x.df[apply(x.df['Freq'],1,function(z) any(z>=1)),]; 
      hhh <- unique(x.df[,c(1:4)])

write.csv(x.df,paste("/nfs/a237/gyeao/results/sim.pop.LS1/","xxdf2",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)  
x.df <- read.csv("/nfs/a237/gyeao/results/sim.pop.LS1/xxdf2.csv", header=T,stringsAsFactors=FALSE) 
rownames(x.df) <- x.df[,1]; x.df <- x.df[,-1]

## join in the lennon and nrts attributes 

x.df <- convert.magic(x.df,c('c','c','c','c','c','n'))
nrts.raw <- convert.magic(nrts.raw[,-1],c('c','c','c','c','c','c','c','c','c','c','c','c','c','c'))

nrts.raw <- nrts.raw[,-c(1:2)]
nrts.templ <- read.csv("/nfs/a237/gyeao/data_nrts/NRTS/150810_Yorkshire and Humberside NRTS dataset.csv", header=T,stringsAsFactors=FALSE)  
nrts.templ$Ind_ID <- nrts.templ[[1]] ; nrts.templ <- nrts.templ[,-1]
nrts.templ['Ind_ID'] <- lapply(nrts.templ['Ind_ID'], as.character)
list(nrts.raw, nrts.templ) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by=c("Ind_ID")), .) -> nrts.rawl
nrts.rawl['Ind_ID'] <- lapply(nrts.rawl['Ind_ID'], as.character)
nrts.raw <- nrts.rawl; 

# zzz <- read.csv("/nfs/a237/gyeao/results/sim.pop.LS/xxdf.csv", header=T,stringsAsFactors=FALSE); x.df <- zzz  
# check1 <- length(setdiff(names(nrts.raw), names(x.df)))

list(x.df, unique(nrts.raw)) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="Ind_ID"), .) -> x.df1 # link in nrts dataset
eee.1 <- setDT(eee, keep.rownames = TRUE)[] # link in lennon simulated datasets from here down ~5 lines
list(x.df1, eee.1) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by=c("O.Code","D.Code","Ticket.TypeID","Passenger.Cat")), .) -> x.df2
names(aaa)[names(aaa)=="id"] <- "rn"
#list(x.df2, aaa) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="rn"), .) -> x.df3
list(x.df2, aaa) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by=c("O.Code","D.Code","Ticket.TypeID","Passenger.Cat","rn")), .) -> x.df4


## sample according to weights         
  sim.pop_ww <- x.df4[rep(row.names(x.df4),x.df4$Freq), 1:(ncol(x.df4)-1)] # multiply out based on weight
  sim.pop_ww <- sim.pop_ww[ , -which(names(sim.pop_ww) %in% c("Freq"))]
  
## sample ascribing uniform weight
#  sim.pop_uu <- x.df4[rep(row.names(x.df4), (x.df4$Freq/x.df4$Freq)), 1:(ncol(x.df4)-1)] # multiply uniformly
#  sim.pop_uu <- sim.pop_uu[sample(nrow(sim.pop_uu),nrow(sim.pop_ww),replace=T), ] # sim.pop_w can be replaced with lennon     
#  sim.pop_uu <- sim.pop_uu[ , -which(names(sim.pop_uu) %in% c("Freq"))]
## 
## attach other attributes from nrts.census  
#sim.pop_w <- convert.magic(sim.pop_ww[,c(1:5)],c('c','c','c','c','c'))
#  sim.pop_u <- convert.magic(sim.pop_uu[,c(1:5)],c('c','c','c','c','c'))
#    nrts.cens <- convert.magic(nrts.cens,c('c','c','c','c','c','c','c','c','c','c')); 
      
#list(sim.pop_w,nrts.cens[!duplicated(nrts.cens[,c('Ind_ID')]),]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="Ind_ID"), .) -> sim.w
#list(sim.pop_u,nrts.cens[!duplicated(nrts.cens[,c('Ind_ID')]),]) %>% Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="Ind_ID"), .) -> sim.u
write.csv(x.df4,paste("/nfs/a237/gyeao/results/sim.pop.LS1/","sim.freq2",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)  
write.csv(sim.pop_ww,paste("/nfs/a237/gyeao/results/sim.pop.LS1/","sim.pop.final2.LS",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)  
sim.pop_ww <- read.csv("/nfs/a237/gyeao/results/sim.pop.LS1/sim.pop.final2.LS.csv", header=T,stringsAsFactors=FALSE)  

#### extracting the distribution of the variables ## this one does not include ethnicity and hse-chldren
#nrts_data11 <- read.csv("/nfs/a237/gyeao/results/detrm_optim/determ_final/nrts_data.csv",header=T,stringsAsFactors=FALSE)  
#### extract data for zone, say BD or LS
#nrts_data11 %>% filter(str_detect(Residence_PC, 'LS1')) -> nrts_data11
#  empty <- data.frame(Var1=character(0), Freq=numeric(0))
#    simu_pop <- nrts_data11
#      for(i in 5:(ncol(simu_pop)-3)){          
#        aa4 <- as.data.frame(table(simu_pop[,i]))  ## useful
#          empty <- rbind(empty, aa4)  }          
#            empty2 <- empty; 
#              empty2$ratio <- empty2$Freq/sum(empty2$Freq); empty2 <- empty2[,-2]
#                empty2 <- convert.magic(empty2,c('c','n'))
                
#cen_var11 <- read.csv("/nfs/a237/gyeao/results/detrm_optim/determ_final/census_bd.csv",header=T,stringsAsFactors=FALSE)  
#### extract data for zone, say BD
#  empty <- data.frame(Var1=character(0), Freq=numeric(0))
#    simu_pop <- cen_var11
#      for(i in 3:(ncol(simu_pop)-0)){
#        aa4 <- as.data.frame(table(simu_pop[,i]))  ## useful
#          empty <- rbind(empty, aa4)  }
#            empty3 <- empty; 
#              empty3 <- empty3[1:23,] 
#                empty3$ratio <- empty3$Freq/sum(empty3$Freq); empty3 <- empty3[,-2]
#                  empty3 <- convert.magic(empty3,c('c','n')) 
            
#empty <- data.frame(Var1=character(0), Freq=numeric(0))
#simu_pop <- sim.w
#  for(i in 9:(ncol(simu_pop))){          
#    aa4 <- as.data.frame(table(simu_pop[,i]))  ## useful
#      empty <- rbind(empty, aa4)  }          
#        empty4 <- empty; 
#          empty4$ratio <- empty4$Freq/sum(empty4$Freq); empty4 <- empty4[,-2]
#            empty4 <- convert.magic(empty4,c('c','n'))
            
#empty <- data.frame(Var1=character(0), Freq=numeric(0))
#simu_pop <- sim.u
#  for(i in 9:(ncol(simu_pop))){          
#    aa4 <- as.data.frame(table(simu_pop[,i]))  ## useful
#      empty <- rbind(empty, aa4)  }          
#        empty5 <- empty; 
#          empty5$ratio <- empty5$Freq/sum(empty5$Freq); empty5 <- empty5[,-2]
#            empty5 <- convert.magic(empty5,c('c','n'))

###### read and write for linux        
#            write.csv(empty2,"/nfs/a237/gyeao/results/final_a/temp_files/empty2.csv",quote=TRUE,na="NA",row.names=TRUE)
#            write.csv(empty3,"/nfs/a237/gyeao/results/final_a/temp_files/empty3.csv",quote=TRUE,na="NA",row.names=TRUE)  
#            write.csv(empty4,"/nfs/a237/gyeao/results/final_a/temp_files/empty4.csv",quote=TRUE,na="NA",row.names=TRUE)  
#            write.csv(empty5,"/nfs/a237/gyeao/results/final_a/temp_files/empty5.csv",quote=TRUE,na="NA",row.names=TRUE)  
            
#            empty2 <- read.csv("/nfs/a237/gyeao/results/final_a/temp_files/empty2.csv",header=T,stringsAsFactors=FALSE)  
#            empty3 <- read.csv("/nfs/a237/gyeao/results/final_a/temp_files/empty3.csv",header=T,stringsAsFactors=FALSE)  
#            empty4 <- read.csv("/nfs/a237/gyeao/results/final_a/temp_files/empty4.csv",header=T,stringsAsFactors=FALSE)  
#            empty5 <- read.csv("/nfs/a237/gyeao/results/final_a/temp_files/empty5.csv",header=T,stringsAsFactors=FALSE) 
        
#### plotting 1
#empty2$ratio <- round(empty2$ratio, digits = 2); empty3$ratio <- round(empty3$ratio, digits = 2);empty4$ratio <- round(empty4$ratio, digits = 2);empty5$ratio <- round(empty5$ratio, digits = 2);
#    list(empty2[,],empty3[,],empty4[,],empty5[,]) %>%  Reduce(function(dtf1,dtf2) full_join(dtf1,dtf2,by="Var1"), .) -> dist ; dist <- dist[,-1]
#      names(dist) <- c('NRTS','Census','Weighted','Uniform')         
#        w.plot <- melt(dist) #; w.plot$value <- 1/log((w.plot$value)) 
#          names(w.plot) <- c('Density','Proportion')
#            cbbPalette <- c("#56B4E9","red","yellow","#009E73")
#              lineSizes <- c(2,2,2,2)  
#                mu <- ddply(w.plot, "Density", summarise, grp.mean=median(Proportion))
#                  p <- ggplot(w.plot, aes(x=Proportion)) + geom_density(aes(colour=Density,group=Density,size=Density), linetype="dotted") + scale_color_manual(values=cbbPalette) + 
#                    scale_size_manual(values=lineSizes) + geom_vline(data=mu, aes(xintercept=grp.mean, color=Density), linetype="dashed", size=c(1,2,3,4) ) ## size=c(3,3,3,3)
#                      grid.newpage();grid.draw(p)
 
#### plot of weighted sim pop, census and uniform sample
#### plotting 2
#empty3$ratio <- round(empty3$ratio, digits = 2);empty4$ratio <- round(empty4$ratio, digits = 2);empty5$ratio <- round(empty5$ratio, digits = 2);
#  list(empty3[,],empty4[,],empty5[,]) %>%  Reduce(function(dtf1,dtf2) full_join(dtf1,dtf2,by="Var1"), .) -> dist ; dist <- dist[,-1]
#    names(dist) <- c('Census','Weighted','Uniform')         
#      w.plot <- melt(dist) #; w.plot$value <- 1/log((w.plot$value)) 
#       names(w.plot) <- c('Density','Proportion')
#          cbbPalette <- c("red","#56B4E9","#009E73")
#            lineSizes <- c(2,2,2)  
#              mu <- ddply(w.plot, "Density", summarise, grp.mean=median(Proportion))
#                p <- ggplot(w.plot, aes(x=Proportion)) + geom_density(aes(colour=Density,group=Density,size=Density), linetype="dotted") + scale_color_manual(values=cbbPalette) + 
#                  scale_size_manual(values=lineSizes) + geom_vline(data=mu, aes(xintercept=grp.mean, color=Density), linetype="dashed", size=c(2,2,3) ) ## size=c(3,3,3,3)
#                    grid.newpage();grid.draw(p)
                      
#### END PROGRAM 

#library(car)
#hist(empty4$ratio)
#lines(density(empty2$ratio, na.rm=T))

#### plotting 3
#### change numbers from 2,3,4,5 for NRTS, Census, Weighted, Uniform
#empty3$Var1 <- as.character(empty3$Var1); empty3$Var1 <- factor(empty3$Var1, levels=unique(empty3$Var1))
#plot(empty3$Var1, empty3$ratio, las=2) # las is label orientation
#lines(empty4$ratio, na.rm=T)

#lennon22 <- unique(lennon)
#nrts.census22 <- unique(nrts.census)
#write.csv(lennon22,paste("/nfs/a237/gyeao/results/detrm_optim/determ_final/","lennon_bd",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)  
#write.csv(nrts.census22,paste("/nfs/a237/gyeao/results/detrm_optim/determ_final/","nrts_census_bd",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)  

#### test cse for thesis
sim.pop2 <- sim.pop_ww
sim.pop2$Distance <- sim.pop2$Ticket.Miles/sim.pop2$Journeys

sim.pop2 <- sim.pop2[(sim.pop2$Ticket.TypeID %in% c("2")), ]
sim.pop2 <- sim.pop2[(sim.pop2$Passenger.Cat %in% c("4")), ]
sim.pop2 <- sim.pop2[(sim.pop2$purpose %in% c("NTC")), ]  # change from TC to NTC for non commute by train 
sim.pop2 <- sim.pop2[(sim.pop2$Income %in% c("step_40")), ]
sim.pop2 <- sim.pop2[(sim.pop2$Cars %in% c("car_3")), ] # "car_2" car_3  car_0
sim.pop2 <- sim.pop2[(sim.pop2$children %in% c("Child_No")), ]
sim.pop2 <- sim.pop2[which(sim.pop2$Distance < 15),]

sim.residence <- as.data.frame(sim.pop2$Residence_PC)
ppp_no_car <- as.data.frame(table(sim.residence)); ppp <- ppp_no_car
names(ppp)[names(ppp) == 'sim.residence'] <- 'com_sec'
write.csv(ppp,paste("/nfs/a237/gyeao/results/sim.pop.LS1/","ppp_leeds_3_2",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE) 

x.df4$Ind_ID <- as.character(x.df4$Ind_ID )
original.nrts$Ind_ID <- as.character(original.nrts$Ind_ID)
list(x.df4,original.nrts) %>%  Reduce(function(dtf1,dtf2) left_join(dtf1,dtf2,by="Ind_ID"), .) -> sim.pop.final.LS1
sim.pop.final.LS1 <- sim.pop.final.LS1[,c(5,1:4,6:135)]
ttt<- sim.pop.final.LS1

ttt <- ttt[1:10,]
ttt2 = setNames(data.frame(t(ttt[,-1])), ttt[,1])
ttt2 <- ttt2[c(1:2,8:48,3:7,49:134),]
rownames(ttt)<- ttt[,1]; ttt<-ttt[,-1]; ttt<-t(ttt[1:10,])

#completeFun <- function(data, desiredCols) {completeVec <- complete.cases(data[, desiredCols]); return(data[completeVec, ])}
#ttt3 <- completeFun(ttt2, "50073750")
#ttt4 <- ttt3[-c(108:115),]
#ttt4 <- convert.magic(ttt4,c('f','f','f','f','f','f','f','f','f','f'))
#write.csv(ttt4,paste("Z:/zzzzzz/","ttt6",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE) 







