# this program performs fully bayesian imputation of missing values in the variables for 
# journey factor, ticket validity period, and flows to group stations
# concept of group station flows can be appleid to flows associated with regional pte tickets 
# change line near 299 to identify directory and name of model text file
#
# to run on 64GB machine use long install, otherwise use short install
# journey factor limited to 9 brethren where ever you may be 211
#
# script for pre-processing of data lies here
#
# a list of all data variables as vectors #
  dataList = list(
      NN = nrow(df) ,
      Nclust = Nclust ,
      clust = clust ,
      onesRepNclust = rep(1,Nclust), 
      
      O_Code = df$O_Code ,
      D_Code = df$D_Code ,
      dist.nominal = df$dist.nominal ,
      TicketValidity2 = df$TicketValidity2 ,
      grp.o.NA = df$grp.o.NA ,
      JF_LENNON = df$JF_LENNON ,
      Orig_PC = df$Orig_PC ,
      Dest_PC = df$Dest_PC ,
      purpose = df$purpose ,
      Income = df$Income ,
      Age = df$Age ,
      Gender = df$Gender ,
      Household = df$Household ,
      Cars = df$Cars ,
      children = df$children ,
      Ethnic = df$Ethnic , 
      TravellingAlone = df$TravellingAlone ,
      StationArrivalTime = df$StationArrivalTime ,
      No_of_stops = df$No_of_stops ,
      Gross.Travel.Time = df$Gross.Travel.Time ,
      ActualArrivalTime = df$ActualArrivalTime ,
      ActualDepartureTime = df$ActualDepartureTime ,
      StationAccessDistance = df$StationAccessDistance ,
      StationEgressDistance = df$StationEgressDistance,
      Max.Validity =df$Max.Validity, 
      isTruncted_JF=df$isTruncted_JF
      )
# impute.mod <- "" this is used for text connection in jags

# manipulate the initial conditions (e.g. 0.25, 0.5 etc.) here
muInit<-df$grp.o.NAA
  Init_TVal.0<-df$Init_TV.0; Init_TVal.1<-df$Init_TV.1; Init_TVal.2<-df$Init_TV.2
      Init_JFact.0<-df$Init_JF.0; Init_JFact.1<-df$Init_JF.1; Init_JFact.2<-df$Init_JF.2
Init1.0<-c(rep(0.25,1)); Init1.1<-c(rep(0.5,1)); Init1.2<-c(rep(0.75,1))
  Init2.0<-c(NA,rep(0.25,1)); Init2.1<-c(NA,rep(0.5,1)); Init2.2<-c(NA,rep(0.75,1))
    Init4.0<-c(NA,rep(0.25,3)); Init4.1<-c(NA,rep(0.5,3)); Init4.2<-c(NA,rep(0.75,3))
      Init7.0<-c(NA,rep(0.25,6)); Init7.1<-c(NA,rep(0.5,6)); Init7.2<-c(NA,rep(0.75,6))
        Init11.0<-c(NA,rep(0.25,10)); Init11.1<-c(NA,rep(0.5,10)); Init11.2<-c(NA,rep(0.75,10))
          Init56.0<-c(NA,rep(0.25,55)); Init56.1<-c(NA,rep(0.5,55)); Init56.2<-c(NA,rep(0.75,55))
            Init303.0<-c(NA,rep(0.25,302)); Init303.1<-c(NA,rep(0.5,302)); Init303.2<-c(NA,rep(0.75,302))
              time24hr.0<-c(NA,rep(0.25,18)); time24hr.1<-c(NA,rep(0.5,18)); time24hr.2<-c(NA,rep(0.75,18))

mob.in <- list(
                    list(
                    JF_LENNON=Init_JFact.0, TicketValidity2=Init_TVal.0, grp.o.NA=muInit, 
                    z.96.0=time24hr.0, z.97.0=time24hr.0,
                    tautau.0=Init1.0, a=Init1.0, alpha.0=Init1.0, veeta.0=Init1.0, zeta.0=Init1.0, heta.0=Init1.0, 
                    z.92.0=Init11.0, beta.0=Init56.0, gamma.0=Init56.0,
                    z.96.1=time24hr.0, z.97.1=time24hr.0,
                    tautau.1=Init1.0,alpha.1=Init1.0, veeta.1=Init1.0, zeta.1=Init1.0, heta.1=Init1.0, 
                    z.92.1=Init11.0,  beta.1=Init56.0, gamma.1=Init56.0,
                    z.96.3=time24hr.0, z.97.3=time24hr.0,
                    alpha.3=Init1.0, veeta.3=Init1.0, heta.3=Init1.0,
                    z.92.3=Init11.0, beta.3=Init56.0, gamma.3=Init56.0,
                    z.96.4=time24hr.0, z.97.4=time24hr.0,
                    alpha.4=Init1.0, veeta.4=Init1.0, 
                    z.92.4=Init11.0, beta.4=Init56.0, gamma.4=Init56.0,
                    
                    a.0=Init303.0, a.1=Init303.0, a.3=Init303.0, a.4=Init303.0,
                    b.0=Init303.0, b.1=Init303.0, b.3=Init303.0, b.4=Init303.0,
                    c.0=Init2.0, c.1=Init2.0, c.3=Init2.0,  c.4=Init2.0,   
                    d.0=Init7.0, d.1=Init7.0, d.3=Init7.0, d.4=Init7.0,                  
                    e.0=Init4.0, e.1=Init4.0, e.3=Init4.0, e.4=Init4.0,                  
                    f.0=Init2.0, f.1=Init2.0, f.3=Init2.0, f.4=Init2.0,                  
                    g.0=Init4.0, g.1=Init4.0, g.3=Init4.0, g.4=Init4.0,                  
                    h.0=Init4.0, h.1=Init4.0, h.3=Init4.0, h.4=Init4.0,                  
                    i.0=Init2.0, i.1=Init2.0, i.3=Init2.0, i.4=Init2.0, 
                    j.0=Init2.0, j.1=Init2.0, j.3=Init2.0, j.4=Init2.0,
                    
                    z.49.0=Init1.0, z.52.0=Init1.0, z.74.0=Init1.0,
                    z.76.0=Init1.0, z.77.0=Init1.0, z.82.0=Init1.0, z.100.0=Init1.0, 
                    z.49.1=Init1.0, z.52.1=Init1.0, z.74.1=Init1.0,
                    z.76.1=Init1.0, z.77.1=Init1.0, z.82.1=Init1.0, z.100.1=Init1.0,  
                    z.49.3=Init1.0, z.52.3=Init1.0, z.74.3=Init1.0,
                    z.76.3=Init1.0, z.77.3=Init1.0, z.82.3=Init1.0, z.100.3=Init1.0, 
                    z.49.4=Init1.0, z.52.4=Init1.0, z.74.4=Init1.0,
                    z.76.4=Init1.0, z.77.4=Init1.0, z.82.4=Init1.0, z.100.4=Init1.0
), 
                    list(
                    JF_LENNON=Init_JFact.1, TicketValidity2=Init_TVal.1, grp.o.NA=muInit,  
                    z.96.0=time24hr.1, z.97.0=time24hr.1,
                    tautau.0=Init1.1, a=Init1.1, alpha.0=Init1.1, veeta.0=Init1.1, zeta.0=Init1.1, heta.0=Init1.1, 
                    z.92.0=Init11.1, beta.0=Init56.1, gamma.0=Init56.1,
                    z.96.1=time24hr.1, z.97.1=time24hr.1,
                    tautau.1=Init1.1, alpha.1=Init1.1, veeta.1=Init1.1, zeta.1=Init1.1, heta.1=Init1.1,
                    z.92.1=Init11.1, beta.1=Init56.1,  gamma.1=Init56.1,
                    z.96.3=time24hr.1, z.97.3=time24hr.1,
                    alpha.3=Init1.1, veeta.3=Init1.1, heta.3=Init1.1,
                    z.92.3=Init11.1, beta.3=Init56.1, gamma.3=Init56.1, 
                    z.96.4=time24hr.1, z.97.4=time24hr.1,
                    alpha.4=Init1.1, veeta.4=Init1.1,  
                    z.92.4=Init11.1, beta.4=Init56.1,  gamma.4=Init56.1,
                     
                    a.0=Init303.1, a.1=Init303.1, a.3=Init303.1, a.4=Init303.1,
                    b.0=Init303.1, b.1=Init303.1, b.3=Init303.1, b.4=Init303.1,
                    c.0=Init2.1, c.1=Init2.1, c.3=Init2.1, c.4=Init2.1,
                    d.0=Init7.1, d.1=Init7.1, d.3=Init7.1, d.4=Init7.1,                  
                    e.0=Init4.1, e.1=Init4.1, e.3=Init4.1, e.4=Init4.1,                  
                    f.0=Init2.1, f.1=Init2.1, f.3=Init2.1, f.4=Init2.1,                  
                    g.0=Init4.1, g.1=Init4.1, g.3=Init4.1, g.4=Init4.1,                  
                    h.0=Init4.1, h.1=Init4.1, h.3=Init4.1, h.4=Init4.1,                  
                    i.0=Init2.1, i.1=Init2.1, i.3=Init2.1, i.4=Init2.1, 
                    j.0=Init2.1, j.1=Init2.1, j.3=Init2.1, j.4=Init2.1,
                     
                    z.49.0=Init1.1, z.52.0=Init1.1, z.74.0=Init1.1,
                    z.76.0=Init1.1, z.77.0=Init1.1, z.82.0=Init1.1, z.100.0=Init1.1, 
                    z.49.1=Init1.1, z.52.1=Init1.1, z.74.1=Init1.1,
                    z.76.1=Init1.1, z.77.1=Init1.1, z.82.1=Init1.1, z.100.1=Init1.1, 
                    z.49.3=Init1.1, z.52.3=Init1.1, z.74.3=Init1.1,
                    z.76.3=Init1.1, z.77.3=Init1.1, z.82.3=Init1.1, z.100.3=Init1.1, 
                    z.49.4=Init1.1, z.52.4=Init1.1, z.74.4=Init1.1,
                    z.76.4=Init1.1, z.77.4=Init1.1, z.82.4=Init1.1, z.100.4=Init1.1
), 
                    list(
                    JF_LENNON=Init_JFact.2, TicketValidity2=Init_TVal.2, grp.o.NA=muInit,  
                    z.96.0=time24hr.2, z.97.0=time24hr.2,
                    tautau.0=Init1.2, a=Init1.2, alpha.0=Init1.2, veeta.0=Init1.2, zeta.0=Init1.2, heta.0=Init1.2, 
                    z.92.0=Init11.2, beta.0=Init56.2, gamma.0=Init56.2,
                    z.96.1=time24hr.2, z.97.1=time24hr.2,
                    tautau.1=Init1.2, alpha.1=Init1.2, veeta.1=Init1.2, zeta.1=Init1.2, heta.1=Init1.2,
                    z.92.1=Init11.2, beta.1=Init56.2,  gamma.1=Init56.2,
                    z.96.3=time24hr.2, z.97.3=time24hr.2,
                    alpha.3=Init1.2, veeta.3=Init1.2, heta.3=Init1.2,
                    z.92.3=Init11.2, beta.3=Init56.2, gamma.3=Init56.2, 
                    z.96.4=time24hr.2, z.97.4=time24hr.2,
                    alpha.4=Init1.2, veeta.4=Init1.2,  
                    z.92.4=Init11.2, beta.4=Init56.2,  gamma.4=Init56.2,
  
                    a.0=Init303.2, a.1=Init303.2, a.3=Init303.2, a.4=Init303.2,
                    b.0=Init303.2, b.1=Init303.2, b.3=Init303.2, b.4=Init303.2,
                    c.0=Init2.2, c.1=Init2.2, c.3=Init2.2, c.4=Init2.2,
                    d.0=Init7.2, d.1=Init7.2, d.3=Init7.2, d.4=Init7.2,                  
                    e.0=Init4.2, e.1=Init4.2, e.3=Init4.2, e.4=Init4.2,                  
                    f.0=Init2.2, f.1=Init2.2, f.3=Init2.2, f.4=Init2.2,                  
                    g.0=Init4.2, g.1=Init4.2, g.3=Init4.2, g.4=Init4.2,                  
                    h.0=Init4.2, h.1=Init4.2, h.3=Init4.2, h.4=Init4.2,                  
                    i.0=Init2.2, i.1=Init2.2, i.3=Init2.2, i.4=Init2.2, 
                    j.0=Init2.2, j.1=Init2.2, j.3=Init2.2, j.4=Init2.2,
                    
                    z.49.0=Init1.2, z.52.0=Init1.2, z.74.0=Init1.2,
                    z.76.0=Init1.2, z.77.0=Init1.2, z.82.0=Init1.2, z.100.0=Init1.2, 
                    z.49.1=Init1.2, z.52.1=Init1.2, z.74.1=Init1.2,
                    z.76.1=Init1.2, z.77.1=Init1.2, z.82.1=Init1.2, z.100.1=Init1.2, 
                    z.49.3=Init1.2, z.52.3=Init1.2, z.74.3=Init1.2,
                    z.76.3=Init1.2, z.77.3=Init1.2, z.82.3=Init1.2, z.100.3=Init1.2, 
                    z.49.4=Init1.2, z.52.4=Init1.2, z.74.4=Init1.2,
                    z.76.4=Init1.2, z.77.4=Init1.2, z.82.4=Init1.2, z.100.4=Init1.2
)
              )  


# end of program
