# this program performs fully bayesian imputation of missing values in the variables for 
# journey factor, ticket validity period, and flows to group stations
# concept of group station flows can be appleid to flows associated with regional pte tickets 
# change line near 299 to identify directory and name of model text file
#
# to run on 64GB machine use long install, otherwise use short install
# journey factor limited to 9 brethren where ever you may be 211
#
install.packages("foreign")
install.packages("plyr")
install.packages("MASS")
install.packages("runjags"); install.packages("rjags") #, "denstrip")
install.packages("dplyr")
install.packages("data.table")
install.packages(c("R2OpenBUGS", "denstrip"))
install.packages("leaps")
install.packages("coda")
install.packages("mcmcplots")
install.packages("magrittr")

library(foreign)
library(plyr)
library(MASS)
library(runjags); library("rjags");
library("dplyr")
library("data.table")
library("R2OpenBUGS"); library("denstrip"); 
library("leaps"); library("coda")
library(coda)
library("mcmcplots")
library("magrittr")  ## for piping

#install.packages("foreign", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("plyr", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("MASS", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("runjags", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("rjags", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("dplyr", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("data.table", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("R2OpenBUGS", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("denstrip", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("leaps", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("coda", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("mcmcplots", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")
#install.packages("magrittr", lib="C:/temp_eusebio/TempRLibs", repos="http://cran.rstudio.com/")

#library(foreign, lib.loc="C:/temp_eusebio/TempRLibs")
#library(plyr, lib.loc="C:/temp_eusebio/TempRLibs")
#library(MASS, lib.loc="C:/temp_eusebio/TempRLibs")
#library(runjags, lib.loc="C:/temp_eusebio/TempRLibs")
#library(rjags, lib.loc="C:/temp_eusebio/TempRLibs")
#library(dplyr, lib.loc="C:/temp_eusebio/TempRLibs")
#library(data.table, lib.loc="C:/temp_eusebio/TempRLibs")
#library(R2OpenBUGS, lib.loc="C:/temp_eusebio/TempRLibs")
#library(denstrip, lib.loc="C:/temp_eusebio/TempRLibs")
#library(leaps, lib.loc="C:/temp_eusebio/TempRLibs")
#library(coda, lib.loc="C:/temp_eusebio/TempRLibs")
#library(mcmcplots, lib.loc="C:/temp_eusebio/TempRLibs")
#library(magrittr, lib.loc="C:/temp_eusebio/TempRLibs")

##################################################
###  MISSING COVARIATES RAILWAY TICKETS
##################################################

getwd() 
#setwd("C:/temp_eusebio")
#setwd("C:/Users/eusebio_odiari/Documents/R")
setwd("C:/Add-GTFS-GIS-2/data_txt_4_bayesian/results")
#
rm(list=ls())

#source("C:/temp_eusebio/plot-functions.R") # depends on denstip 
#source("C:/temp_eusebio/DBDA2E-utilities.R") # depends on denstip 
#source("c:/bugscourse/plot-functions.R") # depends on denstip 
#source("C:/Users/eusebio_odiari/Documents/R/DBDA2E-utilities.R") # depends on denstip 
source("S:/gyeao/analysis_smicrosimulation/nrts_census/project/plot-functions.R") # depends on denstip 
source("S:/gyeao/analysis_smicrosimulation/nrts_census/project/DBDA2E-utilities.R") # depends on denstip 

#load(file="bugscourse.rda")

# function for converting dataformats from character, numeric factor etc.
convert.magic<-function(obj,types){for(j in 1:length(obj)){FUN<-switch(types[j],c=as.character,n=as.numeric,f=as.factor,i=as.integer);obj[,j]<-FUN(obj[,j])};obj}
##
mysample <- function(x){as.data.frame(x);if(all(is.na(x))){return(NA)}else{return(sample(x[!is.na(x)],1))}}

bayes.data <- read.table("bayes_data.txt", header=T)  #, col.names=), skip=1, nrows=100)
header <- read.csv("header.csv",header=T,stringsAsFactors=F)  

# separate variables into observed and missing, continuous and categorical
vec <- colnames(bayes.data)[colSums(is.na(bayes.data)) > 0]
dfff <- bayes.data[,c(99:ncol(bayes.data))]
#
drops <- c("Residence_PC","OriginPostcode","DestPostcode","HomePostcode","ReturnStageID")
bayes.data <- bayes.data[ , !(names(bayes.data) %in% drops)]
#
bayes.data <- bayes.data[!is.na(bayes.data$Orig_PC), ]
bayes.data <- bayes.data[!is.na(bayes.data$Dest_PC), ]
bayes.data <- bayes.data[!is.na(bayes.data$DepartureTimeFirstTrain), ]
bayes.data <- bayes.data[!is.na(bayes.data$StationArrivalTime), ]
#
# sort out data-types integer, factor etc. 
  df <- bayes.data; 
    c <- as.data.frame(t(as.data.frame(lapply(df, class)))); c$value <- t(df[1,])
      c$class_new2 <- strtrim(c$V1, 1); c$miss <- 0##
        for(i in 1:nrow(c)){if(rownames(c)[i] %in% vec){c$miss[i]<-1}else{c$miss[i]<-0}  }
          c$class_new2 <- gsub("f", "c", c$class_new2); c$class_new2 <- gsub("i", "n", c$class_new2)
            df <- convert.magic(df, c$class_new2)
c<- c[with(c, order(miss, class_new2)),]
  df <- setcolorder(df, as.character(rownames(c)))             

# converts origin and destination categories into numbers
df <- df[!(is.na(df$O_Code) | is.na(df$Dest_PC)), ]
  statn <- unique(c(df$O_Code, df$D_Code))
    statn.numb <- seq(1,length(statn),1)
      conv.table <- data.table(O_Code=statn, O_Code2=paste0(statn.numb), key="O_Code")
        df <- transform(df, O_Code=as.integer(as.character(factor(O_Code, levels=statn, labels=statn.numb)))  )
          df <- transform(df, D_Code=as.integer(as.character(factor(D_Code, levels=statn, labels=statn.numb)))  )
  
# converts origin_pc and destn postcode categories into numbers
df <- df[!(is.na(df$Orig_PC) | is.na(df$Dest_PC)), ]
  postcd <- as.factor(unique(c(df$Orig_PC, df$Dest_PC)))
    postcd.numb <- seq(1,length(postcd),1)
      conv.table <- data.table(Orig_PC=postcd, Orig_PC2=paste0(postcd.numb), key="Orig_PC")
        df <- transform(df, Orig_PC=as.integer(as.character(factor(Orig_PC, levels=postcd, labels=postcd.numb)))  )
          df <- transform(df, Dest_PC=as.integer(as.character(factor(Dest_PC, levels=postcd, labels=postcd.numb)))  )
  
write.table(df, "df.txt", row.names=F, sep="\t") 
df <- read.table("df.txt", header=T)  #, col.names=), skip=1, nrows=100)
dfff <- df[,c(99:ncol(df))] # check 
#
YY = vector(); ii<-1; jj<-1
for(i in 1:nrow(df)){
  if(i+1<=nrow(df) & (i >= ii) & df$count_o[i]==2 & df$count_o[i+1]==2){YY[jj]<-paste("YY[",jj,"]~dsum(grp.o.NA[",i,"],grp.o.NA[",i+1,"])", sep=""); ii<-i+2 ; jj<-jj+1}else{
    if(i+2<=nrow(df) & (i >= ii) & df$count_o[i]==3 & df$count_o[i+1]==3 & df$count_o[i+2]==3){YY[jj]<-paste("YY[",jj,"]~dsum(grp.o.NA[",i,"],grp.o.NA[",i+1,"],grp.o.NA[",i+2,"])", sep=""); ii<-i+3; jj<-jj+1}else{
      if(i+3<=nrow(df) & (i >= ii) & df$count_o[i]==4 & df$count_o[i+1]==4 & df$count_o[i+2]==4 & df$count_o[i+3]==4){YY[jj]<-paste("YY[",jj,"]~dsum(grp.o.NA[",i,"],grp.o.NA[",i+1,"],grp.o.NA[",i+2,"],grp.o.NA[",i+3,"])", sep=""); ii<-i+4; jj<-jj+1}else{}
    } } }
YY <- as.data.frame(YY)
print(YY, row.names=F) #copy this into model just after line 78
write.table(YY, "group.o.st.txt", row.names=F, col.names=F, sep="\t") 
write.csv(YY, paste("group.o.st.csv",sep=""),quote=TRUE,na="NA",row.names=F) 

ZZ = vector(); ii<-1; jj<-1
for(i in 1:nrow(df)){
  if(i+1<=nrow(df) & (i >= ii) & df$count_d[i]==2 & df$count_d[i+1]==2){ZZ[jj]<-paste("ZZ[",jj,"]~dsum(grp.d.NA[",i,"],grp.d.NA[",i+1,"])", sep=""); ii<-i+2 ; jj<-jj+1}else{
    if(i+2<=nrow(df) & (i >= ii) & df$count_d[i]==3 & df$count_d[i+1]==3 & df$count_d[i+2]==3){ZZ[jj]<-paste("ZZ[",jj,"]~dsum(grp.d.NA[",i,"],grp.d.NA[",i+1,"],grp.d.NA[",i+2,"])", sep=""); ii<-i+3; jj<-jj+1}else{
      if(i+3<=nrow(df) & (i >= ii) & df$count_d[i]==4 & df$count_d[i+1]==4 & df$count_d[i+2]==4 & df$count_d[i+3]==4){ZZ[jj]<-paste("ZZ[",jj,"]~dsum(grp.d.NA[",i,"],grp.d.NA[",i+1,"],grp.d.NA[",i+2,"],grp.d.NA[",i+3,"])", sep=""); ii<-i+4; jj<-jj+1}else{}
    } } }
ZZ <- as.data.frame(ZZ)
print(ZZ, row.names=F) #copy this into model just after line 78
write.table(ZZ, "group.d.st.txt", row.names=F, col.names=F, sep="\t") 
write.csv(ZZ, paste("group.d.st.csv",sep=""),quote=TRUE,na="NA",row.names=F) 

# build initials for group stations
df$grp.o.NAA <- df$grp.o.NA
for(m in 1:nrow(df)){if(is.na(df$grp.o.NAA[m])){df$grp.o.NAA[m]<-1.0/df$count_o[m]}else{df$grp.o.NAA[m]<-NA}  }

df$grp.d.NAA <- df$grp.d.NA
for(m in 1:nrow(df)){if(is.na(df$grp.d.NAA[m])){df$grp.d.NAA[m]<-1.0/df$count_d[m]}else{df$grp.d.NAA[m]<-NA}  }

# some initial conditions for the missing journey factors 
df$k <- 2 # steepness of curve # 3
df$L <- 4 # curve's maximum value on y-axis less 1 # 4
df$x0 <- mean(df$dist.nominal[])  # sum(df$dist.nominal[])/10 # nrow(dist.nominal[])# x-value of midpoint
#
df$YYY <- 1
  df$YY <- 1
    df$ZZ <- 1
      df$MM <- 1
        df$MMM <- 1

dfff <- df[,c(99:ncol(df))] # check

# extract information on the type - char, numeric, fatcor etc.of fields of dataframe.
c <- as.data.frame(t(as.data.frame(lapply(df, class)))); c$value <- t(df[1,])
  names(c)[names(c)=="V1"] <- "class_old"
    c$class_new <- as.character(c$class_old)
      c$identity <- seq.int(nrow(c)); 
#c <- c[,c(4,1,3,2)]

c$class_new2 <- strtrim(c$class_new, 1)##
c3 <- c$class_new2
df <- convert.magic(df, c3) #c3)
#
df$NN <- nrow(df) ## 200
df$Gross.Travel.Time <- df$in.carr.time + df$in.netwk.wait + df$wait.b4.train
df$No_of_stops <- as.integer(as.character(df$No_of_stops))

# converts arrival and departure times to categorical 24 (or less) steps and then into numbers
df$ActualArrivalTime <- as.character(round(df$ActualArrivalTime,0))
  df$ActualDepartureTime <- as.character(round(df$ActualDepartureTime,0))
    statn <- unique(c(df$ActualArrivalTime, df$ActualDepartureTime))
      statn.numb <- seq(1,length(statn),1)
        conv.table <- data.table(ActualArrivalTime=statn, ActualArrivalTime2=paste0(statn.numb), key="ActualArrivalTime")
          df <- transform(df, ActualArrivalTime=as.integer(as.character(factor(ActualArrivalTime, levels=statn, labels=statn.numb)))  )
            df <- transform(df, ActualDepartureTime=as.integer(as.character(factor(ActualDepartureTime, levels=statn, labels=statn.numb)))  )

# final ammendments to ticket validity2 and min and max validity 
  for(ii in 1:nrow(df)){if(is.na(df$TicketValidity2[ii])){df$TicketValidity2[ii]<-NA}else{df$TicketValidity2[ii]<-round((df$cost.nominal[ii]*(df$TicketValidity2[ii])^(-1))*100, 0) }  }
    for(jj in 1:nrow(df)){df$Min.Validity[jj]<-round((df$cost.nominal[jj]*(df$Min.Validity[jj])^(-1))*100, 0)}
      for(kk in 1:nrow(df)){df$Max.Validity[kk]<-round((df$cost.nominal[kk]*(df$Max.Validity[kk])^(-1))*100, 0)}
            
# censoring limits for ticket validity2
  for(m in 1:nrow(df)){if(is.na(df$TicketValidity2[m])){df$isCensored_TV[m]<-1}else{df$isCensored_TV[m]<-0}   }            
    dfff <- df[,c(99:ncol(df))] # check
      for(m in 1:nrow(df)){if(df$isCensored_TV[m]==1){df$Init_TV.0[m]<-df$Min.Validity[m]+1}else{df$Init_TV.0[m]<-NA}   }            
        for(m in 1:nrow(df)){if(df$isCensored_TV[m]==1){df$Init_TV.1[m]<-df$Min.Validity[m]+2}else{df$Init_TV.1[m]<-NA}   }            
          for(m in 1:nrow(df)){if(df$isCensored_TV[m]==1){df$Init_TV.2[m]<-df$Min.Validity[m]+3}else{df$Init_TV.2[m]<-NA}   }            
    
# truncation for journey factor imputation           
  for(m in 1:nrow(df)){if(is.na(df$JF_LENNON[m])){df$indx_JF[m]<-1}else{df$indx_JF[m]<-0}   }            
  for(m in 1:nrow(df)){if(is.na(df$JF_LENNON[m])){df$isTruncted_JF[m]<-9}else{df$isTruncted_JF[m]<-df$JF_LENNON[m]}   }            
    dfff <- df[,c(99:ncol(df))] # check
      for(m in 1:nrow(df)){if(df$indx_JF[m]==1){df$Init_JF.0[m]<-1}else{df$Init_JF.0[m]<-NA}   }            
        for(m in 1:nrow(df)){if(df$indx_JF[m]==1){df$Init_JF.1[m]<-2}else{df$Init_JF.1[m]<-NA}   }            
          for(m in 1:nrow(df)){if(df$indx_JF[m]==1){df$Init_JF.2[m]<-3}else{df$Init_JF.2[m]<-NA}   }            

# clustering data details 
    Nclust = 2
    clust = rep(NA,nrow(df)) 
    clust[which.min(df$JF_LENNON)]=1 # smallest value is assigned to cluster 1
    clust[which.max(df$JF_LENNON)]=Nclust # highest value is assigned to cluster 4 
#   clust[round(median(y),0)]=2 # clust[round(mean(y),0)]=2; 
      
    dfff <- df[,c(99:ncol(df))] # check
#
# a list of all data variables as vectors # ibe anyi ka mmadu zue ike, ah ah!
  dataList = list(
      NN = nrow(df) ,
      Nclust = Nclust ,
      clust = clust ,
      onesRepNclust = rep(1,Nclust), 
      
      O_Code = df$O_Code ,
      D_Code = df$D_Code ,
      dist.nominal = df$dist.nominal ,
      TicketValidity2 = df$TicketValidity2 ,
      grp.o.NA = df$grp.o.NA ,
      JF_LENNON = df$JF_LENNON ,
      Orig_PC = df$Orig_PC ,
      Dest_PC = df$Dest_PC ,
      purpose = df$purpose ,
      Income = df$Income ,
      Age = df$Age ,
      Gender = df$Gender ,
      Household = df$Household ,
      Cars = df$Cars ,
      children = df$children ,
      Ethnic = df$Ethnic , 
      TravellingAlone = df$TravellingAlone ,
      StationArrivalTime = df$StationArrivalTime ,
      No_of_stops = df$No_of_stops ,
      Gross.Travel.Time = df$Gross.Travel.Time ,
      ActualArrivalTime = df$ActualArrivalTime ,
      ActualDepartureTime = df$ActualDepartureTime ,
      StationAccessDistance = df$StationAccessDistance ,
      StationEgressDistance = df$StationEgressDistance,
      Max.Validity =df$Max.Validity, 
      isTruncted_JF=df$isTruncted_JF
      )
# impute.mod <- "" this is used for text connection in jags

# initial conditions lie here 

# model run options rjags # reference the kruschke book
# copy the model .txt file to c: drive for faster runs 
# this option uses 3 chains on 3 parallel pc cores, make sure pc has upto 4 cores so 1 spare
#
# imp.jag <- jags.model(textConnection(impute.mod), df, initials, n.chains=2) only in r.jags not in run.jags
initials <- mob.in
# model='C:/temp_eusebio/impute.mod_v5c.txt',
imp.jag <- run.jags(method='parallel', model='C:/Add-GTFS-GIS-2/data_txt_4_bayesian/results/impute.mod_v5h.txt', 
                    monitor=c("JF_LENNON[9796]","JF_LENNON[8374]","JF_LENNON[8376]","JF_LENNON[8632]","JF_LENNON[9305]","JF_LENNON[9595]","JF_LENNON[4964]","JF_LENNON[4971]","JF_LENNON[4979]",
                              "TicketValidity2[5478]","TicketValidity2[4207]","TicketValidity2[3992]","TicketValidity2[4093]","TicketValidity2[4145]","TicketValidity2[4256]","TicketValidity2[4311]","TicketValidity2[3825]","TicketValidity2[3888]",
                              "grp.o.NA[3]","grp.o.NA[5]","grp.o.NA[30]","grp.o.NA[1886]","grp.o.NA[1859]","grp.o.NA[1858]","grp.o.NA[1055]","grp.o.NA[863]","grp.o.NA[1967]",
                              "veeta.0","zeta.0"), 
                    data=dataList, inits=initials, n.chains=3, burnin=1001, sample=3000 )


CodaSamples <- as.mcmc.list(imp.jag) 

# save mcmc object
# save(CodaSamples, file= "C:/temp_eusebio/storage/CodaSamp51dd_5b.txt")
# save(CodaSamples, file= "C:/temp_eusebio/storage/CodaSamp51dd_5b.csv")
save(CodaSamples, file= "C:/Add-GTFS-GIS-2/data_txt_4_bayesian/results/CodaSamp_5h.txt")
save(CodaSamples, file= "C:/Add-GTFS-GIS-2/data_txt_4_bayesian/results/CodaSamp_5h.csv")

# plot functions from krusche 
diagMCMC(codaObject=CodaSamples, parName="veeta.0") # distance
diagMCMC(codaObject=CodaSamples, parName="zeta.0") # cost # also see other parameters
diagMCMC(codaObject=CodaSamples, parName="JF_LENNON[4979]")
diagMCMC(codaObject=CodaSamples, parName="TicketValidity2[5478]")
diagMCMC(codaObject=CodaSamples, parName="grp.o.NA[3]")

CodaSamples2 <- window(CodaSamples, 1001, 3000)
summary(CodaSamples)
plot(CodaSamples2, ask=TRUE)

# end of program
print(imp.jag, digits=4) 
  par(mfrow=c(2,3))
    traceplot(sample) #par(new=TRUE) 
      par(mfrow=c(2,3))
        densplot.discrete(sample) ## run the following # source("c:/bugscourse/plot-functions.R") # depends on denstip

# notes on dsum problems, and some links i might have found useful in my own journey
# https://stackoverflow.com/questions/37956257/node-inconsistent-with-parents-in-jags-model-r
# http://biometry.github.io/APES//LectureNotes/StatsCafe/Linear_models_jags.html
# https://stackoverflow.com/questions/34113672/jags-error-for-mcmc-bayesian-inference/34117608#34117608
# https://www.stats.ox.ac.uk/~nicholls/MScMCMC15/jags_user_manual.pdf
# https://blog.aidanfindlater.com/2016/09/12/poisson-and-negbin-in-jags/
# http://homepage.stat.uiowa.edu/~gwoodwor/BBIText/AppendixBWinbugs.pdf
# http://doingbayesiandataanalysis.blogspot.co.uk/2012/01/complete-example-of-right-censoring-in.html ## complete example of right censoring in JAGS
# mixture.models.R http://doingbayesiandataanalysis.blogspot.co.uk/2012/06/mixture-of-normal-distributions.html
# mixture models 2 http://www.johnmyleswhite.com/notebook/2010/10/19/em-and-regression-mixture-modeling/
# mixture 3 https://www.coursera.org/learn/mcmc-bayesian-statistics/lecture/KDEVZ/mixture-model-in-jags
d <- density(na.omit(df$JF_LENNON)) # returns the density data
plot(d) 
dev.off()
        