#
install.packages("foreign")
install.packages("plyr")
install.packages("MASS")
install.packages("rjags") #, "denstrip")
install.packages("dplyr")
install.packages("data.table")
#install.packages(c("R2OpenBUGS", "denstrip"))
install.packages(c("R2WinBUGS", "denstrip"))
install.packages("leaps")
install.packages("mcmcplots")
install.packages("magrittr")

install.packages("maptools")
install.packages("maps")

library(foreign)
library(plyr)
library(MASS)
library("rjags"); 
library("dplyr")
library("data.table")
#library("R2OpenBUGS"); library("denstrip"); 
library("R2WinBUGS"); library("denstrip"); 
library("leaps"); library("coda")
library("mcmcplots")
library("magrittr")  ## for piping

library(maptools) # loads sp library too
library(maps) 

##################################################
###  MISSING COVARIATES RAILWAY TICKETS##################################################

getwd() 
setwd("S:/gyeao/tempo_euse_PC_100318") # ("C:/temp_eusebio_2/models") # #setwd("C:/cambridge-adv-bugs-myone") #setwd("C:\advanced_bayes_material\practical_material")# # "C:/Users/eusebio_odiari/Documents/R"
rm(list=ls())

source("plot-functions.R") # depends on denstip

# function for converting dataformats from character, numeric factor etc.
convert.magic<-function(obj,types){for(j in 1:length(obj)){FUN<-switch(types[j],c=as.character,n=as.numeric,f=as.factor,i=as.integer);obj[,j]<-FUN(obj[,j])};obj}
mysample <- function(x){as.data.frame(x);if(all(is.na(x))){return(NA)}else{return(sample(x[!is.na(x)],1))}}
insertRow <- function(existingDF, newrow, r){existingDF[seq(r+1,nrow(existingDF)+1),] <- existingDF[seq(r,nrow(existingDF)),]; existingDF[r,] <- newrow; existingDF }
#
bayes.data <- read.table("bayes_data.txt", header=T)  #, col.names=), skip=1, nrows=100)
header <- read.csv("header.csv",header=T,stringsAsFactors=F)  
zone.samples <- 1 # number of zones + 1

x<-readShapePoly("wy_fitted")
plot(x) # display the shapefile
closeAllConnections()

# sp2WB(x, "wy_fitted22.txt") # works on my uni pc # note '.txt' extension # convert the shape file into splus format to import into GeoBugs
#
# separate variables into observed and missing, continuous and categorical
vec <- colnames(bayes.data)[colSums(is.na(bayes.data)) > 0]
dfff <- bayes.data[,c(99:ncol(bayes.data))]
#
# drops <- c("Residence_PC","DepartureTimeFirstTrain","ReturnStageID","StationArrivalTime","OriginPostcode","DestPostcode","HomePostcode")
drops <- c("Residence_PC","OriginPostcode","DestPostcode","HomePostcode","ReturnStageID")
bayes.data <- bayes.data[ , !(names(bayes.data) %in% drops)]
#
bayes.data <- bayes.data[!is.na(bayes.data$Orig_PC), ]
bayes.data <- bayes.data[!is.na(bayes.data$Dest_PC), ]
bayes.data <- bayes.data[!is.na(bayes.data$DepartureTimeFirstTrain), ]
bayes.data <- bayes.data[!is.na(bayes.data$StationArrivalTime), ]
#
# sort out data-types integer, factor etc. 
  df <- bayes.data; 
    c <- as.data.frame(t(as.data.frame(lapply(df, class)))); c$value <- t(df[1,])
      c$class_new2 <- strtrim(c$V1, 1); c$miss <- 0##
        for(i in 1:nrow(c)){if(rownames(c)[i] %in% vec){c$miss[i]<-1}else{c$miss[i]<-0}  }
          c$class_new2 <- gsub("f", "c", c$class_new2); c$class_new2 <- gsub("i", "n", c$class_new2)
            df <- convert.magic(df, c$class_new2)
c<- c[with(c, order(miss, class_new2)),]
  df <- setcolorder(df, as.character(rownames(c)))             

# converts o_code and d_code station categories into numbers
df <- df[!(is.na(df$O_Code) | is.na(df$Dest_PC)), ]
  statn <- unique(c(df$O_Code, df$D_Code))
    statn.numb <- seq(1,length(statn),1)
      conv.table <- data.table(O_Code=statn, O_Code2=paste0(statn.numb), key="O_Code")
        df <- transform(df, O_Code=as.integer(as.character(factor(O_Code, levels=statn, labels=statn.numb)))  )
          df <- transform(df, D_Code=as.integer(as.character(factor(D_Code, levels=statn, labels=statn.numb)))  )
  
          dfff <- df[,c(99:ncol(df))] # check
          
# converts origin_pc and destn postcode categories into numbers # dfff <- df[,c(99:ncol(df))]
xx <- x@data # check
xx$wy_clip_co <- as.character(xx$wy_clip_co)
df <- left_join(df,xx[,c(1,3,4)],by=c("Orig_PC"="wy_clip_co") )
  df <- left_join(df,xx[,c(1,3,4)],by=c("Dest_PC"="wy_clip_co") )
    names(df)[names(df)=="adj.x"] <- "O.pc.adj"
      names(df)[names(df)=="adj.y"] <- "D.pc.adj"
        df$O.pc.adj <- factor(df$O.pc.adj, levels=c(as.character(xx$adj)))
          df$D.pc.adj <- factor(df$D.pc.adj, levels=c(as.character(xx$adj)))

# drop variables that are not required for car.models
for(i in 1:nrow(df)){df$Gross.Travel.Time[i] <- df$in.carr.time[i] + df$in.netwk.wait[i] + df$wait.b4.train[i]}
df$No_of_stops <- as.character(df$No_of_stops)
df <- df[,c("Freq","O_Code","D_Code","O.pc.adj","D.pc.adj","JF_LENNON","AccessMode1","EgressMode1","StationAccessDistance","StationEgressDistance","Product_Desc",
                            "dist.nominal","cost.nominal","TravellingAlone","No_of_stops","Gross.Travel.Time",
                            "purpose","Income","Age","Gender","Household","Cars","children","Max.Validity","Shape_Area.x")]
#
# fillin journey factor by say 1.7 # convert access distance for poisson
for(i in 1:nrow(df)){if(is.na(df$JF_LENNON[i])){df$JF_LENNON[i] <- 1.7}else{}     }
for(i in 1:nrow(df)){df$StationAccessDistance[i] <- as.integer(df$StationAccessDistance[i]*100)}
 
# check # as.data.frame(table(test.data$O_Code))# we only consider origin in gwr sp interaction
abc.1 <- as.data.frame(table(df$O.pc.adj))
  abc.2 <- as.data.frame(table(df$D.pc.adj))
    min(abc.1$Freq); max(abc.1$Freq)
#      abc.1[abc.1$Freq==max(abc.1$Freq), ]
#        abc.1[abc.1$Freq==min(abc.1$Freq), ]

# extract unique sets 
ccc.0 <- df; 
newrow <- c(rep(NA,ncol(ccc.0)   ))

# start of loop of interest
empty.0 <- data.frame(matrix(nrow=0, ncol=length(newrow))); names(empty.0) <- names(ccc.0) # try joshua ulrich
  ccc.0 %>% subset(!duplicated(ccc.0$O.pc.adj)) %>% arrange(O.pc.adj) %>% assign("ddd.1",.,pos=1)
    empty.0 %>% rbind(empty.0,ddd.1 ) %>% assign("empty.0",.,pos=1)
    
      for(i in 1:nrow(abc.1)){  
        index <- factor(as.character(i),levels=levels(empty.0$O.pc.adj))
          if(i > nrow(empty.0)){empty.0<-insertRow(empty.0, newrow, i)}else if((empty.0$O.pc.adj[i]!=index) & !is.na(empty.0$O.pc.adj[i]) ){   
            empty.0<-insertRow(empty.0, newrow, i)}else{} } # ;print(i)}else{} }
              empty.0 <- empty.0[!(row.names(empty.0) %in% c("NA")),  ]; rownames(empty.0) <- NULL
#
# set all missing 'NA' freq to '0', and origin zones to those not yet used   
# for(i in 1:nrow(empty.0)){if(is.na(empty.0$Freq[i])){empty.0$Freq[i] <- 1}else{}    }              
      
 vec1 <- na.omit(as.character(empty.0$O.pc.adj))     
  vec2 <- as.character(xx$adj)     
    vec3 <- setdiff(vec2, vec1)
      vec3 <- factor(vec3, levels=c(as.character(xx$adj))) # check length(vec3)
        jj <- 1; for(j in 1:nrow(empty.0)){if(is.na(empty.0$O.pc.adj[j])){empty.0$O.pc.adj[j]<-vec3[jj]; jj<-jj+1}else{  }  }  

        empty.01 <- empty.0        

#     
for(k in 1:zone.samples){
empty.0 <- data.frame(matrix(nrow=0, ncol=length(newrow))); names(empty.0) <- names(ccc.0) # try joshua ulrich
  ccc.0 %>% subset(duplicated(ccc.0$O.pc.adj)) %>% assign("ccc.0",.,pos=1) 
    ccc.0 %>% subset(!duplicated(ccc.0$O.pc.adj)) %>% arrange(O.pc.adj) %>% assign("ddd.1",.,pos=1)
      empty.0 %>% rbind(empty.0,ddd.1 ) %>% assign("empty.0",.,pos=1)
        for(i in 1:nrow(abc.1)){  
          index <- factor(as.character(i),levels=levels(empty.0$O.pc.adj))
            if(i > nrow(empty.0)){empty.0<-insertRow(empty.0, newrow, i)}else if((empty.0$O.pc.adj[i]!=index) & !is.na(empty.0$O.pc.adj[i]) ){   
          empty.0<-insertRow(empty.0, newrow, i)}else{} }
        empty.0 <- empty.0[!(row.names(empty.0) %in% c("NA")),  ]; rownames(empty.0) <- NULL
      # for(i in 1:nrow(empty.0)){if(is.na(empty.0$Freq[i])){empty.0$Freq[i] <- 0}else{}    }              
    vec1 <- na.omit(as.character(empty.0$O.pc.adj))     
  vec2 <- as.character(xx$adj)     
vec3 <- setdiff(vec2, vec1)
vec3 <- factor(vec3, levels=c(as.character(xx$adj))) # check length(vec3)
jj <- 1; for(j in 1:nrow(empty.0)){if(is.na(empty.0$O.pc.adj[j])){empty.0$O.pc.adj[j]<-vec3[jj]; jj<-jj+1}else{}} 

empty.02 <- empty.0
empty.01 <- rbind(empty.01,empty.02)}

# tester Y = structure(.Data = c(empty.01$Freq), .Dim=c(338,zone.samples+1)) 
# plot(density(empty.01$StationAccessDistance)) # check

# set all missing 'NA' in covariates to '0' to enable Bayesian regression  
# for(i in 1:nrow(empty.01)){if(is.na(empty.01$StationAccessDistance[i])){empty.01$StationAccessDistance[i] <- 0}else{}    }   
for(i in 1:nrow(empty.01)){if(is.na(empty.01$StationEgressDistance[i])){empty.01$StationEgressDistance[i] <- 0}else{}    } ; empty.01$StationEgressDistance <- as.numeric(as.character(empty.01$StationEgressDistance))/100.0            
for(i in 1:nrow(empty.01)){if(is.na(empty.01$Shape_Area.x[i])){empty.01$Shape_Area.x[i] <- 0}else{}    }              
for(i in 1:nrow(empty.01)){if(is.na(empty.01$Gross.Travel.Time[i])){empty.01$Gross.Travel.Time[i] <- 0}else{}    } ; empty.01$Gross.Travel.Time <- as.numeric(as.character(empty.01$Gross.Travel.Time)) /200.0            
for(i in 1:nrow(empty.01)){if(is.na(empty.01$dist.nominal[i])){empty.01$dist.nominal[i] <- 0}else{}    }              
for(i in 1:nrow(empty.01)){if(is.na(empty.01$No_of_stops[i])){empty.01$No_of_stops[i] <- 0}else{}    }              
for(i in 1:nrow(empty.01)){if(is.na(empty.01$TravellingAlone[i])){empty.01$TravellingAlone[i] <- 0}else{}    }              
for(i in 1:nrow(empty.01)){if(is.na(empty.01$cost.nominal[i])){empty.01$cost.nominal[i] <- 0}else{}    }              
 
for(i in 1:nrow(empty.01)){if(is.na(empty.01$EgressMode1[i])){empty.01$EgressMode1[i] <- 0}else{}    }; empty.01$EgressMode1 <- as.numeric(as.character(empty.01$EgressMode1))/100.0            
for(i in 1:nrow(empty.01)){if(is.na(empty.01$AccessMode1[i])){empty.01$AccessMode1[i] <- 0}else{}    }; empty.01$AccessMode1 <- as.numeric(as.character(empty.01$AccessMode1))/100.0            
for(i in 1:nrow(empty.01)){if(is.na(empty.01$No_of_stops[i])){empty.01$No_of_stops[i] <- 0}else{}    }; empty.01$No_of_stops <- as.numeric(as.character(empty.01$No_of_stops))/100.0            
for(i in 1:nrow(empty.01)){if(is.na(empty.01$Cars[i])){empty.01$Cars[i] <- 0}else{}    }; 
        for(i in 1:nrow(empty.01)){if(empty.01$Cars[i]=='car_0'){empty.01$Cars[i] <- '0'
        }else if(empty.01$Cars[i]=='car_1'){empty.01$Cars[i] <- '1'
          }else if(empty.01$Cars[i]=='car_2'){empty.01$Cars[i] <- '2'
            }else if(empty.01$Cars[i]=='car_3'){empty.01$Cars[i] <- '3'} else{}}   
              empty.01$Cars <- as.numeric(as.character(empty.01$Cars))/100.0            
for(i in 1:nrow(empty.01)){if(is.na(empty.01$Income[i])){empty.01$Income[i] <- 0}else{}    }; 
        for(i in 1:nrow(empty.01)){if(empty.01$Income[i]=='step_10'){empty.01$Income[i] <- '1'
        }else if(empty.01$Income[i]=='step_20'){empty.01$Income[i] <- '2'
          }else if(empty.01$Income[i]=='step_30'){empty.01$Income[i] <- '3'
            }else if(empty.01$Income[i]=='step_40'){empty.01$Income[i] <- '4'
              }else if(empty.01$Income[i]=='step_50'){empty.01$Income[i] <- '5'
                }else if(empty.01$Income[i]=='step_60'){empty.01$Income[i] <- '6'
                  }else if(empty.01$Income[i]=='step_70'){empty.01$Income[i] <- '7'} else{}}   
              empty.01$Income <- as.numeric(as.character(empty.01$Income))/100.0            
for(i in 1:nrow(empty.01)){if(is.na(empty.01$Age[i])){empty.01$Age[i] <- 0}else{}    }; 
        for(i in 1:nrow(empty.01)){if(empty.01$Age[i]=='Age16_24'){empty.01$Age[i] <- '1'
        }else if(empty.01$Age[i]=='Age25_34'){empty.01$Age[i] <- '2'
          }else if(empty.01$Age[i]=='Age35_64'){empty.01$Age[i] <- '3'
            }else if(empty.01$Age[i]=='Age65_'){empty.01$Age[i] <- '4'} else{}}   
              empty.01$Age <- as.numeric(as.character(empty.01$Age))/100.0            
              
# at this stage create adjacency in openBUGS or winBUGS
# export as txt using sp2WB maptools, maps # openBUGS file-open maps import to save it as *.map # adjacency #
# data forinput tomodel
dataList = list(
          Nareas=338, Ndiseases=zone.samples+1, 
          zero = c(0,0), 
          R = structure(.Data = c(0.02, 0, 0, 0.02), .Dim=c(zone.samples+1,zone.samples+1)),
          Q = structure(.Data = c(0.01, 0, 0, 0.01), .Dim=c(zone.samples+1,zone.samples+1)),
          Y = structure(.Data = c(empty.01$StationAccessDistance), .Dim=c(338,zone.samples+1)),
          E = structure(.Data = c(empty.01$Shape_Area.x), .Dim=c(338,zone.samples+1)),
          
          X = structure(.Data = c(empty.01$Age), .Dim=c(338,zone.samples+1)),
          
          num = c(5, 5, 5, 8, 5, 8, 6, 2, 5, 5, 7, 7, 8, 7, 5, 6, 6, 5, 6, 9, 5, 10, 4, 5, 4, 8, 5, 5, 7, 6, 9, 8, 4, 7, 6, 5, 7, 9, 2, 4, 4, 5, 4, 6, 8, 7, 5, 6, 3, 11, 
                  2, 6, 7, 6, 8, 7, 4, 8, 6, 6, 6, 5, 8, 6, 7, 6, 5, 6, 6, 8, 6, 6, 6, 8, 4, 5, 8, 7, 6, 7, 8, 6, 12, 5, 6, 8, 7, 7, 5, 5, 5, 3, 7, 5, 7, 5, 4, 2, 5, 4, 
                  6, 4, 5, 6, 5, 5, 5, 5, 5, 4, 6, 9, 7, 5, 6, 6, 7, 7, 7, 10, 5, 6, 4, 5, 6, 4, 4, 8, 5, 8, 5, 5, 5, 4, 6, 8, 5, 6, 4, 5, 11, 3, 4, 9, 4, 11, 3, 8, 6, 8, 7, 5, 4, 8, 6, 6, 5, 4, 8, 7, 5, 7, 7, 8, 6, 10, 6, 8, 5, 7, 
                  4, 4, 6, 7, 5, 6, 6, 7, 5, 8, 4, 7, 6, 7, 7, 4, 5, 4, 7, 3, 7, 3, 2, 5, 2, 4, 4, 7, 4, 4, 4, 5, 5, 11, 6, 7, 10, 6, 4, 9, 
                  6, 5, 6, 6, 7, 5, 7, 5, 4, 8, 6, 8, 5, 6, 7, 6, 9, 5, 5, 6, 4, 7, 5, 6, 7, 6, 7, 5, 6, 5, 5, 5, 8, 4, 9, 6, 6, 7, 3, 5, 3, 5, 6, 5, 7, 5, 6, 7, 4, 8, 7, 4, 6, 4, 7, 6, 6, 4, 7, 7, 
                  5, 6, 5, 5, 8, 5, 9, 4, 9, 6, 8, 9, 5, 8, 8, 3, 5, 6, 8, 5, 6, 4, 5, 6, 5, 5, 6, 8, 6, 3, 4, 5, 6, 5, 8, 5, 4, 4, 3, 5, 7, 4, 9, 8, 4, 4, 6, 9, 4, 2, 9, 6, 8, 3, 3, 6, 4, 3, 6, 4, 5, 4, 2, 5, 5, 2, 6, 8
          ),
          adj = c(58, 5, 4, 3, 2, 70, 64, 58, 3, 1, 70, 69, 4, 2, 1, 69, 54, 52, 35, 32, 5, 3, 1, 314, 58, 54, 4, 1, 210, 180, 179, 34, 27, 26, 8, 7, 34, 33, 32, 27, 8, 6, 7, 6, 338, 313, 304, 55, 31, 318, 311, 307, 306, 305, 118, 114, 63, 16, 14, 13, 12, 118, 117, 114, 67, 63, 16, 11, 308, 68, 19, 18, 17, 16, 14, 11, 114, 113, 50, 17, 15, 13, 11, 50, 45, 20, 17, 14, 68, 67, 65, 13, 12, 11, 308, 20, 19, 15, 14, 13, 308, 74, 68, 19, 13, 308, 74, 20, 18, 17, 13, 74, 45, 44, 30, 23, 21, 19, 17, 15, 44, 37, 23, 22, 20, 218, 217, 216, 185, 37, 30, 25, 24, 23, 21, 30, 22, 21, 20, 30, 29, 26, 25, 22, 185, 26, 24, 22, 185, 180, 29, 28, 27, 25, 24, 6, 32, 28, 26, 7, 6, 72, 32, 29, 27, 26, 74, 73, 72, 30, 28, 26, 24, 74, 29, 24, 23, 22, 20, 338, 313, 311, 310, 309, 306, 266, 263, 9, 72, 69, 35, 33, 28, 27, 7, 4, 35, 34, 32, 7, 210, 53, 52, 35, 33, 7, 6, 53, 52, 34, 
                  33, 32, 4, 219, 215, 40, 38, 37, 219, 218, 44, 38, 36, 22, 21, 47, 46, 44, 43, 42, 40, 39, 37, 36, 46, 38, 215, 51, 38, 36, 48, 47, 45, 42, 47, 45, 43, 41, 38, 45, 44, 42, 38, 45, 43, 38, 37, 21, 20, 50, 48, 44, 43, 42, 41, 20, 15, 132, 50, 49, 48, 47, 39, 38, 48, 46, 42, 41, 38, 50, 49, 47, 46, 45, 41, 50, 48, 46, 133, 132, 113, 112, 111, 49, 48, 46, 45, 15, 14, 215, 40, 312, 54, 53, 35, 34, 4, 312, 213, 210, 56, 52, 35, 34, 314, 312, 56, 52, 5, 4, 313, 304, 214, 213, 154, 57, 56, 9, 314, 312, 213, 57, 55, 54, 53, 314, 313, 56, 55, 315, 314, 66, 64, 60, 5, 2, 1, 315, 314, 313, 305, 61, 60, 315, 66, 63, 61, 59, 58, 313, 305, 63, 62, 60, 59, 305, 119, 118, 63, 61, 118, 67, 66, 62, 61, 60, 12, 11, 71, 70, 66, 65, 58, 2, 71, 70, 68, 67, 66, 64, 16, 67, 65, 64, 63, 60, 58, 66, 65, 63, 16, 12, 74, 71, 65, 18, 16, 13, 73, 72, 70, 32, 4, 3, 73, 72, 71, 69, 65, 64, 
                  3, 2, 74, 73, 70, 68, 65, 64, 73, 70, 69, 32, 29, 28, 74, 72, 71, 70, 69, 29, 73, 71, 68, 30, 29, 20, 19, 18, 80, 79, 78, 76, 80, 79, 78, 77, 75, 90, 89, 87, 86, 85, 80, 78, 76, 85, 84, 83, 79, 77, 76, 75, 83, 82, 80, 78, 76, 75, 90, 82, 81, 79, 77, 76, 75, 318, 316, 260, 91, 90, 88, 82, 80, 125, 91, 83, 81, 80, 79, 129, 125, 124, 123, 121, 94, 93, 92, 84, 82, 79, 78, 93, 92, 85, 83, 78, 93, 87, 86, 84, 78, 77, 104, 103, 96, 95, 89, 87, 85, 77, 103, 102, 101, 93, 86, 85, 77, 262, 261, 260, 95, 90, 89, 81, 95, 90, 88, 86, 77, 89, 88, 81, 80, 77, 317, 316, 125, 82, 81, 93, 84, 83, 102, 94, 92, 87, 85, 84, 83, 102, 101, 99, 93, 83, 284, 261, 97, 96, 89, 88, 86, 335, 104, 97, 95, 86, 335, 284, 96, 95, 104, 99, 104, 101, 100, 98, 94, 104, 103, 101, 99, 103, 102, 100, 99, 94, 87, 101, 94, 93, 87, 104, 101, 100, 87, 86, 103, 100, 99, 98, 96, 86, 120, 117, 116, 109, 106, 120, 115, 109, 107, 105, 115, 112, 109, 108, 106, 116, 112, 110, 109, 107, 116, 108, 107, 106, 105, 
                  116, 113, 112, 108, 133, 130, 127, 126, 112, 50, 128, 127, 115, 113, 111, 110, 108, 107, 50, 117, 116, 114, 112, 110, 50, 14, 117, 113, 14, 12, 11, 128, 122, 120, 112, 107, 106, 117, 113, 110, 109, 108, 105, 120, 118, 116, 114, 113, 105, 12, 120, 119, 117, 63, 62, 12, 11, 318, 317, 307, 305, 120, 118, 62, 317, 125, 124, 122, 119, 118, 117, 115, 106, 105, 129, 128, 123, 122, 83, 128, 124, 123, 121, 120, 115, 124, 122, 121, 83, 125, 123, 122, 120, 83, 317, 124, 120, 91, 83, 82, 130, 128, 127, 111, 128, 126, 112, 111, 130, 129, 127, 126, 122, 121, 115, 112, 
                  332, 130, 128, 121, 83, 332, 329, 133, 131, 129, 128, 126, 111, 331, 329, 133, 132, 130, 331, 133, 131, 50, 46, 132, 131, 130, 111, 50, 220, 137, 136, 135, 220, 184, 181, 140, 137, 134, 220, 150, 146, 141, 139, 138, 137, 134, 140, 138, 136, 135, 134, 183, 182, 140, 139, 137, 136, 182, 141, 138, 136, 183, 181, 138, 137, 135, 238, 235, 203, 182, 165, 146, 144, 143, 142, 139, 136, 146, 143, 141, 146, 144, 142, 141, 279, 278, 277, 208, 203, 148, 146, 143, 141, 207, 155, 149, 148, 319, 208, 150, 149, 148, 147, 144, 143, 142, 141, 136, 
                  319, 148, 146, 319, 208, 207, 149, 147, 146, 145, 144, 319, 155, 150, 148, 146, 145, 220, 155, 153, 152, 151, 149, 146, 136, 222, 221, 220, 159, 157, 152, 150, 159, 154, 153, 151, 150, 155, 154, 152, 150, 304, 214, 207, 159, 155, 153, 152, 55, 207, 154, 153, 150, 149, 145, 222, 211, 210, 177, 158, 157, 222, 159, 158, 156, 151, 211, 159, 157, 156, 214, 212, 211, 158, 157, 154, 152, 151, 326, 232, 176, 164, 163, 162, 161, 166, 164, 163, 162, 160, 323, 196, 194, 176, 166, 161, 160, 320, 168, 167, 166, 164, 161, 160, 236, 235, 232, 168, 167, 163, 161, 160, 235, 204, 203, 169, 167, 141, 204, 199, 198, 197, 196, 169, 168, 163, 162, 161, 
                  235, 169, 168, 165, 164, 163, 320, 198, 197, 169, 167, 166, 164, 163, 204, 168, 167, 166, 165, 321, 226, 225, 222, 178, 177, 171, 321, 178, 172, 170, 321, 178, 173, 171, 321, 189, 187, 180, 178, 172, 326, 322, 231, 230, 229, 176, 175, 323, 322, 321, 176, 174, 326, 323, 175, 174, 162, 160, 222, 210, 179, 178, 170, 156, 180, 179, 177, 173, 172, 171, 170, 210, 180, 178, 177, 6, 189, 186, 185, 179, 178, 173, 26, 6, 184, 183, 140, 135, 238, 237, 227, 183, 141, 139, 138, 227, 184, 182, 181, 140, 138, 227, 224, 223, 220, 183, 181, 135, 217, 216, 186, 180, 26, 25, 22, 216, 189, 185, 180, 323, 321, 189, 188, 173, 217, 215, 189, 187, 217, 216, 
                  188, 187, 186, 180, 173, 323, 192, 191, 324, 323, 195, 194, 193, 192, 190, 193, 191, 190, 192, 191, 324, 323, 196, 191, 162, 324, 191, 199, 194, 166, 162, 204, 198, 168, 166, 204, 202, 200, 199, 197, 168, 166, 200, 198, 196, 166, 202, 201, 199, 198, 251, 245, 202, 200, 245, 204, 201, 200, 198, 279, 204, 165, 144, 141, 280, 279, 245, 205, 203, 202, 198, 197, 169, 166, 165, 291, 280, 248, 245, 244, 204, 338, 277, 269, 267, 253, 209, 207, 338, 304, 267, 209, 208, 206, 155, 154, 148, 145, 277, 209, 207, 148, 146, 144, 277, 208, 207, 206, 213, 212, 211, 179, 177, 156, 53, 34, 6, 214, 212, 210, 159, 158, 156, 214, 213, 211, 210, 159, 214, 212, 210, 56, 55, 53, 213, 212, 211, 159, 154, 55, 219, 218, 217, 188, 51, 40, 36, 217, 189, 186, 185, 22, 218, 216, 215, 189, 188, 185, 22, 219, 217, 215, 37, 22, 218, 215, 37, 36, 223, 221, 184, 151, 150, 136, 135, 134, 325, 225, 223, 222, 220, 151, 325, 225, 221, 177, 170, 157, 156, 151, 
                  225, 224, 221, 220, 184, 228, 227, 226, 225, 223, 184, 325, 226, 224, 223, 222, 221, 170, 322, 321, 228, 225, 224, 170, 237, 234, 230, 229, 228, 224, 184, 183, 182, 322, 229, 227, 226, 224, 322, 230, 228, 227, 174, 234, 233, 231, 229, 227, 174, 326, 233, 230, 174, 326, 237, 236, 234, 233, 164, 160, 326, 234, 232, 231, 230, 237, 236, 233, 232, 230, 227, 327, 238, 236, 167, 165, 164, 141, 327, 237, 235, 234, 232, 164, 327, 238, 236, 234, 232, 227, 182, 327, 237, 235, 182, 141, 276, 275, 243, 242, 241, 240, 279, 276, 272, 241, 239, 280, 279, 242, 240, 239, 291, 280, 243, 241, 239, 291, 290, 281, 275, 274, 273, 242, 239, 
                  248, 247, 245, 205, 251, 250, 247, 246, 244, 205, 204, 202, 201, 298, 296, 295, 250, 247, 245, 298, 295, 248, 246, 245, 244, 298, 293, 291, 290, 247, 244, 205, 297, 296, 250, 296, 251, 249, 246, 245, 250, 245, 201, 288, 285, 284, 261, 255, 289, 277, 269, 256, 254, 206, 289, 288, 256, 255, 253, 288, 261, 258, 257, 256, 254, 252, 269, 257, 255, 254, 253, 270, 269, 259, 258, 256, 255, 265, 262, 261, 260, 259, 257, 255, 270, 265, 258, 257, 337, 318, 265, 264, 262, 258, 88, 81, 284, 262, 258, 255, 252, 95, 88, 261, 260, 258, 88, 337, 310, 266, 265, 264, 31, 
                  337, 265, 263, 260, 270, 266, 264, 263, 260, 259, 258, 338, 271, 270, 265, 263, 31, 338, 271, 269, 268, 207, 206, 271, 270, 269, 267, 270, 268, 267, 257, 256, 253, 206, 271, 269, 268, 266, 265, 259, 257, 338, 270, 268, 267, 266, 289, 279, 278, 277, 276, 240, 283, 282, 281, 274, 243, 285, 283, 275, 273, 243, 289, 287, 286, 285, 276, 274, 243, 239, 289, 275, 272, 240, 239, 289, 279, 278, 272, 253, 209, 208, 206, 144, 279, 277, 272, 144, 280, 278, 277, 272, 241, 240, 204, 203, 144, 291, 279, 242, 241, 205, 204, 303, 294, 293, 292, 290, 282, 273, 243, 336, 335, 334, 333, 303, 284, 283, 281, 273, 285, 284, 282, 274, 273, 335, 285, 283, 282, 261, 252, 97, 95, 288, 287, 286, 284, 283, 275, 274, 252, 287, 285, 275, 289, 288, 286, 285, 275, 289, 287, 285, 255, 254, 252, 288, 287, 277, 276, 275, 272, 254, 253, 293, 291, 281, 248, 243, 290, 280, 248, 243, 242, 205, 298, 294, 293, 281, 298, 292, 290, 281, 248, 303, 299, 298, 297, 292, 281, 298, 297, 296, 247, 246, 297, 295, 250, 249, 246, 299, 298, 296, 295, 294, 249, 
                  297, 295, 294, 293, 292, 248, 247, 246, 303, 302, 301, 300, 297, 294, 302, 301, 299, 334, 302, 300, 299, 334, 303, 301, 300, 299, 334, 302, 299, 294, 282, 281, 338, 207, 154, 55, 9, 313, 307, 306, 119, 62, 61, 59, 10, 313, 311, 305, 31, 10, 318, 305, 119, 10, 19, 18, 17, 13, 311, 310, 31, 337, 311, 309, 263, 31, 337, 318, 310, 309, 306, 31, 10, 56, 54, 53, 52, 314, 306, 305, 61, 59, 57, 55, 31, 9, 315, 313, 59, 58, 57, 56, 54, 5, 314, 60, 59, 58, 318, 317, 91, 81, 318, 316, 125, 120, 119, 91, 337, 317, 316, 311, 307, 260, 119, 81, 10, 149, 148, 147, 146, 168, 163, 323, 322, 226, 187, 175, 173, 172, 171, 170, 
                  321, 229, 228, 226, 175, 174, 321, 194, 191, 190, 187, 176, 175, 162, 195, 194, 191, 225, 222, 221, 233, 232, 231, 176, 174, 160, 238, 237, 236, 235, 331, 330, 329, 332, 331, 330, 328, 131, 130, 332, 331, 329, 328, 330, 329, 328, 132, 131, 330, 329, 130, 129, 334, 282, 333, 303, 302, 301, 282, 336, 284, 282, 97, 96, 335, 282, 318, 311, 310, 264, 263, 260, 304, 271, 267, 266, 207, 206, 31, 9
          ),
          sumNumNeigh = 1974)
#
# initial conditions for variables of model
  empty.01$StationAccess.init <- empty.01$StationAccessDistance; 
    for(i in 1:nrow(empty.01)){if(is.na(empty.01$StationAccessDistance[i])){empty.01$StationAccess.init[i]<-1}else{empty.01$StationAccess.init[i]<-NA}  }
      YY = structure(.Data = c(empty.01$StationAccess.init), .Dim=c(338,zone.samples+1))
         SS = t(structure(.Data = c(rep(0,nrow(empty.01))), .Dim=c(338,zone.samples+1)))
            UU = structure(.Data = c(rep(0,nrow(empty.01))), .Dim=c(338,zone.samples+1))
  
initial <- list(
  list(alpha = c(-0.02,-0.07), beta = c(rep(1,(nrow(empty.01)/2))), omega = structure(.Data=c(40, 0, 0, 10), .Dim=c(2,2)), Y = YY, S = SS),
  list(alpha = c(-0.09,-0.02), beta = c(rep(0,(nrow(empty.01)/2))), omega = structure(.Data = c(35.81,-20.98,-20.98,23.12),.Dim = c(2,2)), Y = YY, S = SS, U=UU),
  list(alpha = c(-0.092,-0.021), beta = c(rep(2,(nrow(empty.01)/2))), omega = structure(.Data = c(35.81,-20.98,-20.98,30.0),.Dim = c(2,2)), Y = YY, S = SS, U=UU+0.1),
  list(alpha = c(-0.0925,-0.0215), beta = c(rep(0,(nrow(empty.01)/2))), omega = structure(.Data = c(35.81,-10.98,-10.98,23.12),.Dim = c(2,2)), Y = YY, S = SS, U=UU),
  list(alpha = c(-0.09253,-0.02152), beta = c(rep(0,(nrow(empty.01)/2))), omega = structure(.Data = c(35.81,-8.98,-8.98,23.12),.Dim = c(2,2)), Y = YY, S = SS, U=UU+0.2))

#initial <- list(
#  list(alpha = c(-0.02,-0.07), omega = structure(.Data=c(40, 0, 0, 10), .Dim=c(2,2)), Y = YY, S = SS),
#  list(alpha = c(-0.09,-0.02), omega = structure(.Data = c(35.81,-20.98,-20.98,23.12),.Dim = c(2,2)), Y = YY, S = SS, U=UU),
#  list(alpha = c(-0.092,-0.021), omega = structure(.Data = c(35.81,-20.98,-20.98,30.0),.Dim = c(2,2)), Y = YY, S = SS, U=UU+0.1),
#  list(alpha = c(-0.0925,-0.0215), omega = structure(.Data = c(35.81,-10.98,-10.98,23.12),.Dim = c(2,2)), Y = YY, S = SS, U=UU),
#  list(alpha = c(-0.09253,-0.02152), omega = structure(.Data = c(35.81,-8.98,-8.98,23.12),.Dim = c(2,2)), Y = YY, S = SS, U=UU+0.2))

initials <- initial 

# model details
model.run <- bugs(
  data=dataList, inits=initials, model="car.bym.final.v8888888.i.txt",
    working.directory="S:/gyeao/tempo_euse_PC_100318",
      n.chains=5, n.burnin=10000, n.iter=30000,
        param=c("RR1","pS","pU","QR80","resQR80","pX","sumvar"),DIC=FALSE,debug=F,bugs.directory="C:/temp_eusebio/winbugs14_unrestricted/WinBUGS14/") # note debug=F ensures handle is returned to R script

# https://aheblog.com/2014/01/08/solution-for-trap-66-postcondition-violated/
print(model.run, digits=4) 
mal.coda <- as.mcmc.list(model.run)
summary(mal.coda)

write.csv(model.run$summary,paste0("mcmc",".summary",".csv")) # write output of model
write.csv(model.run$sims.matrix,paste0("mcmc",".full",".csv")) # write output of model

summary(model.run)
plot(mal.coda, ask=TRUE)

# end of program
#e <- sd(SS[1, ])*sd(SS[1, ]) + sd(UU[ ,1])*sd(UU[ ,1]) + sd(log(subset(E[ ,1], E[ , 1] > 0)))*sd(log(subset(E[ ,1], E[ , 1] > 0)))
sumvar <- 22.31207
pX <- 24.68064
p <- sd(log(subset(E[ ,1], E[ , 1] > 0)))*sd(log(subset(E[ ,1], E[ , 1] > 0)))

pe <- p/(sumvar + p)
pxx <- pX/(sumvar + p)

fff <-  empty.01[1:338,]
fff$O.pc.adj <- as.character(fff$O.pc.adj)
xx$adj <- as.character(xx$adj)

fff.1 <- left_join(fff,xx[,c(1,4)], by=c("O.pc.adj"="adj") ) 
  
df <- left_join(df,xx[,c(1,3,4)],by=c("Orig_PC"="wy_clip_co") )                  
                   
                   